/*
//@HEADER
// ************************************************************************
//
//            LOCA: Library of Continuation Algorithms Package
//                 Copyright (2005) Sandia Corporation
//
// Under terms of Contract DE-AC04-94AL85000, there is a non-exclusive
// license for use of this work by or on behalf of the U.S. Government.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are
// met:
//
// 1. Redistributions of source code must retain the above copyright
// notice, this list of conditions and the following disclaimer.
//
// 2. Redistributions in binary form must reproduce the above copyright
// notice, this list of conditions and the following disclaimer in the
// documentation and/or other materials provided with the distribution.
//
// 3. Neither the name of the Corporation nor the names of the
// contributors may be used to endorse or promote products derived from
// this software without specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY SANDIA CORPORATION "AS IS" AND ANY
// EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
// PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SANDIA CORPORATION OR THE
// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
// EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
// PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
// PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
// LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// Questions? Contact Roger Pawlowski (rppawlo@sandia.gov) or
// Eric Phipps (etphipp@sandia.gov), Sandia National Laboratories.
// ************************************************************************
//  CVS Information
//  $Source$
//  $Author$
//  $Date$
//  $Revision$
// ************************************************************************
//@HEADER
*/

/* ----------------------------------------------------------------------------
 * This file was automatically generated by SWIG (http://www.swig.org).
 * Version 1.3.23
 *
 * This file is not intended to be easily readable and contains a number of
 * coding conventions designed to improve portability and efficiency. Do not make
 * changes to this file unless you know what you are doing--modify the SWIG
 * interface file instead.
 * ----------------------------------------------------------------------------- */

#define SWIGPYTHON

#ifdef __cplusplus
template<class T> class SwigValueWrapper {
    T *tt;
public:
    SwigValueWrapper() : tt(0) { }
    SwigValueWrapper(const SwigValueWrapper<T>& rhs) : tt(new T(*rhs.tt)) { }
    SwigValueWrapper(const T& t) : tt(new T(t)) { }
    ~SwigValueWrapper() { delete tt; }
    SwigValueWrapper& operator=(const T& t) { delete tt; tt = new T(t); return *this; }
    operator T&() const { return *tt; }
    T *operator&() { return tt; }
private:
    SwigValueWrapper& operator=(const SwigValueWrapper<T>& rhs);
};
#endif


#ifndef SWIG_TEMPLATE_DISAMBIGUATOR
#  if defined(__SUNPRO_CC)
#    define SWIG_TEMPLATE_DISAMBIGUATOR template
#  else
#    define SWIG_TEMPLATE_DISAMBIGUATOR
#  endif
#endif


#include <Python.h>

/***********************************************************************
 * common.swg
 *
 *     This file contains generic SWIG runtime support for pointer
 *     type checking as well as a few commonly used macros to control
 *     external linkage.
 *
 * Author : David Beazley (beazley@cs.uchicago.edu)
 *
 * Copyright (c) 1999-2000, The University of Chicago
 *
 * This file may be freely redistributed without license or fee provided
 * this copyright message remains intact.
 ************************************************************************/

#include <string.h>

#if defined(_WIN32) || defined(__WIN32__) || defined(__CYGWIN__)
#  if !defined(STATIC_LINKED)
#    define SWIGEXPORT(a) __declspec(dllexport) a
#  else
#    define SWIGEXPORT(a) a
#  endif
#else
#  define SWIGEXPORT(a) a
#endif

#define SWIGRUNTIME(x) static x

#ifndef SWIGINLINE
#if defined(__cplusplus) || (defined(__GNUC__) && !defined(__STRICT_ANSI__))
#  define SWIGINLINE inline
#else
#  define SWIGINLINE
#endif
#endif


/* This should only be incremented when either the layout of swig_type_info changes,
   or for whatever reason, the runtime changes incompatibly */
#define SWIG_RUNTIME_VERSION "1"

/* define SWIG_TYPE_TABLE_NAME as "SWIG_TYPE_TABLE" */
#ifdef SWIG_TYPE_TABLE
#define SWIG_QUOTE_STRING(x) #x
#define SWIG_EXPAND_AND_QUOTE_STRING(x) SWIG_QUOTE_STRING(x)
#define SWIG_TYPE_TABLE_NAME SWIG_EXPAND_AND_QUOTE_STRING(SWIG_TYPE_TABLE)
#else
#define SWIG_TYPE_TABLE_NAME
#endif

#ifdef __cplusplus
extern "C" {
#endif

typedef void *(*swig_converter_func)(void *);
typedef struct swig_type_info *(*swig_dycast_func)(void **);

typedef struct swig_type_info {
  const char             *name;
  swig_converter_func     converter;
  const char             *str;
  void                   *clientdata;
  swig_dycast_func        dcast;
  struct swig_type_info  *next;
  struct swig_type_info  *prev;
} swig_type_info;

static swig_type_info *swig_type_list = 0;
static swig_type_info **swig_type_list_handle = &swig_type_list;

/*
   Compare two type names skipping the space characters, therefore
   "char*" == "char *" and "Class<int>" == "Class<int >", etc.

   Return 0 when the two name types are equivalent, as in
   strncmp, but skipping ' '.
*/
static int
SWIG_TypeNameComp(const char *f1, const char *l1,
          const char *f2, const char *l2) {
  for (;(f1 != l1) && (f2 != l2); ++f1, ++f2) {
    while ((*f1 == ' ') && (f1 != l1)) ++f1;
    while ((*f2 == ' ') && (f2 != l2)) ++f2;
    if (*f1 != *f2) return *f1 - *f2;
  }
  return (l1 - f1) - (l2 - f2);
}

/*
  Check type equivalence in a name list like <name1>|<name2>|...
*/
static int
SWIG_TypeEquiv(const char *nb, const char *tb) {
  int equiv = 0;
  const char* te = tb + strlen(tb);
  const char* ne = nb;
  while (!equiv && *ne) {
    for (nb = ne; *ne; ++ne) {
      if (*ne == '|') break;
    }
    equiv = SWIG_TypeNameComp(nb, ne, tb, te) == 0;
    if (*ne) ++ne;
  }
  return equiv;
}


/* Register a type mapping with the type-checking */
static swig_type_info *
SWIG_TypeRegister(swig_type_info *ti) {
  swig_type_info *tc, *head, *ret, *next;
  /* Check to see if this type has already been registered */
  tc = *swig_type_list_handle;
  while (tc) {
    /* check simple type equivalence */
    int typeequiv = (strcmp(tc->name, ti->name) == 0);
    /* check full type equivalence, resolving typedefs */
    if (!typeequiv) {
      /* only if tc is not a typedef (no '|' on it) */
      if (tc->str && ti->str && !strstr(tc->str,"|")) {
    typeequiv = SWIG_TypeEquiv(ti->str,tc->str);
      }
    }
    if (typeequiv) {
      /* Already exists in the table.  Just add additional types to the list */
      if (ti->clientdata) tc->clientdata = ti->clientdata;
      head = tc;
      next = tc->next;
      goto l1;
    }
    tc = tc->prev;
  }
  head = ti;
  next = 0;

  /* Place in list */
  ti->prev = *swig_type_list_handle;
  *swig_type_list_handle = ti;

  /* Build linked lists */
  l1:
  ret = head;
  tc = ti + 1;
  /* Patch up the rest of the links */
  while (tc->name) {
    head->next = tc;
    tc->prev = head;
    head = tc;
    tc++;
  }
  if (next) next->prev = head;
  head->next = next;

  return ret;
}

/* Check the typename */
static swig_type_info *
SWIG_TypeCheck(char *c, swig_type_info *ty) {
  swig_type_info *s;
  if (!ty) return 0;        /* Void pointer */
  s = ty->next;             /* First element always just a name */
  do {
    if (strcmp(s->name,c) == 0) {
      if (s == ty->next) return s;
      /* Move s to the top of the linked list */
      s->prev->next = s->next;
      if (s->next) {
        s->next->prev = s->prev;
      }
      /* Insert s as second element in the list */
      s->next = ty->next;
      if (ty->next) ty->next->prev = s;
      ty->next = s;
      s->prev = ty;
      return s;
    }
    s = s->next;
  } while (s && (s != ty->next));
  return 0;
}

/* Cast a pointer up an inheritance hierarchy */
static SWIGINLINE void *
SWIG_TypeCast(swig_type_info *ty, void *ptr) {
  if ((!ty) || (!ty->converter)) return ptr;
  return (*ty->converter)(ptr);
}

/* Dynamic pointer casting. Down an inheritance hierarchy */
static swig_type_info *
SWIG_TypeDynamicCast(swig_type_info *ty, void **ptr) {
  swig_type_info *lastty = ty;
  if (!ty || !ty->dcast) return ty;
  while (ty && (ty->dcast)) {
    ty = (*ty->dcast)(ptr);
    if (ty) lastty = ty;
  }
  return lastty;
}

/* Return the name associated with this type */
static SWIGINLINE const char *
SWIG_TypeName(const swig_type_info *ty) {
  return ty->name;
}

/* Return the pretty name associated with this type,
   that is an unmangled type name in a form presentable to the user.
*/
static const char *
SWIG_TypePrettyName(const swig_type_info *type) {
  /* The "str" field contains the equivalent pretty names of the
     type, separated by vertical-bar characters.  We choose
     to print the last name, as it is often (?) the most
     specific. */
  if (type->str != NULL) {
    const char *last_name = type->str;
    const char *s;
    for (s = type->str; *s; s++)
      if (*s == '|') last_name = s+1;
    return last_name;
  }
  else
    return type->name;
}

/* Search for a swig_type_info structure */
static swig_type_info *
SWIG_TypeQuery(const char *name) {
  swig_type_info *ty = *swig_type_list_handle;
  while (ty) {
    if (ty->str && (SWIG_TypeEquiv(ty->str,name))) return ty;
    if (ty->name && (strcmp(name,ty->name) == 0)) return ty;
    ty = ty->prev;
  }
  return 0;
}

/* Set the clientdata field for a type */
static void
SWIG_TypeClientData(swig_type_info *ti, void *clientdata) {
  swig_type_info *tc, *equiv;
  if (ti->clientdata) return;
  /* if (ti->clientdata == clientdata) return; */
  ti->clientdata = clientdata;
  equiv = ti->next;
  while (equiv) {
    if (!equiv->converter) {
      tc = *swig_type_list_handle;
      while (tc) {
        if ((strcmp(tc->name, equiv->name) == 0))
          SWIG_TypeClientData(tc,clientdata);
        tc = tc->prev;
      }
    }
    equiv = equiv->next;
  }
}

/* Pack binary data into a std::string */
static char *
SWIG_PackData(char *c, void *ptr, size_t sz) {
  static char hex[17] = "0123456789abcdef";
  unsigned char *u = (unsigned char *) ptr;
  const unsigned char *eu =  u + sz;
  register unsigned char uu;
  for (; u != eu; ++u) {
    uu = *u;
    *(c++) = hex[(uu & 0xf0) >> 4];
    *(c++) = hex[uu & 0xf];
  }
  return c;
}

/* Unpack binary data from a std::string */
static char *
SWIG_UnpackData(char *c, void *ptr, size_t sz) {
  register unsigned char uu = 0;
  register int d;
  unsigned char *u = (unsigned char *) ptr;
  const unsigned char *eu =  u + sz;
  for (; u != eu; ++u) {
    d = *(c++);
    if ((d >= '0') && (d <= '9'))
      uu = ((d - '0') << 4);
    else if ((d >= 'a') && (d <= 'f'))
      uu = ((d - ('a'-10)) << 4);
    d = *(c++);
    if ((d >= '0') && (d <= '9'))
      uu |= (d - '0');
    else if ((d >= 'a') && (d <= 'f'))
      uu |= (d - ('a'-10));
    *u = uu;
  }
  return c;
}

/* This function will propagate the clientdata field of type to
* any new swig_type_info structures that have been added into the list
* of equivalent types.  It is like calling
* SWIG_TypeClientData(type, clientdata) a second time.
*/
static void
SWIG_PropagateClientData(swig_type_info *type) {
  swig_type_info *equiv = type->next;
  swig_type_info *tc;
  if (!type->clientdata) return;
  while (equiv) {
    if (!equiv->converter) {
      tc = *swig_type_list_handle;
      while (tc) {
        if ((strcmp(tc->name, equiv->name) == 0) && !tc->clientdata)
          SWIG_TypeClientData(tc, type->clientdata);
        tc = tc->prev;
      }
    }
    equiv = equiv->next;
  }
}

#ifdef __cplusplus
}
#endif

/* -----------------------------------------------------------------------------
 * SWIG API. Portion that goes into the runtime
 * ----------------------------------------------------------------------------- */

#ifdef __cplusplus
extern "C" {
#endif

/* -----------------------------------------------------------------------------
 * for internal method declarations
 * ----------------------------------------------------------------------------- */

#ifndef SWIGINTERN
#define SWIGINTERN static
#endif

#ifndef SWIGINTERNSHORT
#ifdef __cplusplus
#define SWIGINTERNSHORT static inline
#else /* C case */
#define SWIGINTERNSHORT static
#endif /* __cplusplus */
#endif


/* Common SWIG API */
#define SWIG_ConvertPtr(obj, pp, type, flags)    SWIG_Python_ConvertPtr(obj, pp, type, flags)
#define SWIG_NewPointerObj(p, type, flags)       SWIG_Python_NewPointerObj(p, type, flags)
#define SWIG_MustGetPtr(p, type, argnum, flags)  SWIG_Python_MustGetPtr(p, type, argnum, flags)

/* Python-specific SWIG API */
#define SWIG_newvarlink()                             SWIG_Python_newvarlink()
#define SWIG_addvarlink(p, name, get_attr, set_attr)  SWIG_Python_addvarlink(p, name, get_attr, set_attr)
#define SWIG_ConvertPacked(obj, ptr, sz, ty, flags)   SWIG_Python_ConvertPacked(obj, ptr, sz, ty, flags)
#define SWIG_NewPackedObj(ptr, sz, type)              SWIG_Python_NewPackedObj(ptr, sz, type)
#define SWIG_InstallConstants(d, constants)           SWIG_Python_InstallConstants(d, constants)

/*
  Exception handling in wrappers
*/
#define SWIG_fail                goto fail
#define SWIG_arg_fail(arg)       SWIG_Python_ArgFail(arg)
#define SWIG_append_errmsg(msg)   SWIG_Python_AddErrMesg(msg,0)
#define SWIG_preppend_errmsg(msg) SWIG_Python_AddErrMesg(msg,1)
#define SWIG_type_error(type,obj) SWIG_Python_TypeError(type,obj)
#define SWIG_null_ref(type)       SWIG_Python_NullRef(type)

/*
  Contract support
*/
#define SWIG_contract_assert(expr, msg) \
 if (!(expr)) { PyErr_SetString(PyExc_RuntimeError, (char *) msg ); goto fail; } else

/* -----------------------------------------------------------------------------
 * Constant declarations
 * ----------------------------------------------------------------------------- */

/* Constant Types */
#define SWIG_PY_INT     1
#define SWIG_PY_FLOAT   2
#define SWIG_PY_STRING  3
#define SWIG_PY_POINTER 4
#define SWIG_PY_BINARY  5

/* Constant information structure */
typedef struct swig_const_info {
    int type;
    char *name;
    long lvalue;
    double dvalue;
    void   *pvalue;
    swig_type_info **ptype;
} swig_const_info;

/* -----------------------------------------------------------------------------
 * Pointer declarations
 * ----------------------------------------------------------------------------- */
/*
  Use SWIG_NO_COBJECT_TYPES to force the use of std::strings to represent
  C/C++ pointers in the python side. Very useful for debugging, but
  not always safe.
*/
#if !defined(SWIG_NO_COBJECT_TYPES) && !defined(SWIG_COBJECT_TYPES)
#  define SWIG_COBJECT_TYPES
#endif

/* Flags for pointer conversion */
#define SWIG_POINTER_EXCEPTION     0x1
#define SWIG_POINTER_DISOWN        0x2

/* -----------------------------------------------------------------------------
 * Alloc. memory flags
 * ----------------------------------------------------------------------------- */
#define SWIG_OLDOBJ  1
#define SWIG_NEWOBJ  SWIG_OLDOBJ + 1
#define SWIG_PYSTR   SWIG_NEWOBJ + 1

#ifdef __cplusplus
}
#endif


/***********************************************************************
 * pyrun.swg
 *
 *     This file contains the runtime support for Python modules
 *     and includes code for managing global variables and pointer
 *     type checking.
 *
 * Author : David Beazley (beazley@cs.uchicago.edu)
 ************************************************************************/

#ifdef __cplusplus
extern "C" {
#endif

/* -----------------------------------------------------------------------------
 * global variable support code.
 * ----------------------------------------------------------------------------- */

typedef struct swig_globalvar {
  char       *name;                  /* Name of global variable */
  PyObject *(*get_attr)();           /* Return the current value */
  int       (*set_attr)(PyObject *); /* Set the value */
  struct swig_globalvar *next;
} swig_globalvar;

typedef struct swig_varlinkobject {
  PyObject_HEAD
  swig_globalvar *vars;
} swig_varlinkobject;

static PyObject *
swig_varlink_repr(swig_varlinkobject *v) {
  v = v;
  return PyString_FromString("<Global variables>");
}

static int
swig_varlink_print(swig_varlinkobject *v, FILE *fp, int flags) {
  swig_globalvar  *var;
  flags = flags;
  fprintf(fp,"Global variables { ");
  for (var = v->vars; var; var=var->next) {
    fprintf(fp,"%s", var->name);
    if (var->next) fprintf(fp,", ");
  }
  fprintf(fp," }\n");
  return 0;
}

static PyObject *
swig_varlink_getattr(swig_varlinkobject *v, char *n) {
  swig_globalvar *var = v->vars;
  while (var) {
    if (strcmp(var->name,n) == 0) {
      return (*var->get_attr)();
    }
    var = var->next;
  }
  PyErr_SetString(PyExc_NameError,"Unknown C global variable");
  return NULL;
}

static int
swig_varlink_setattr(swig_varlinkobject *v, char *n, PyObject *p) {
  swig_globalvar *var = v->vars;
  while (var) {
    if (strcmp(var->name,n) == 0) {
      return (*var->set_attr)(p);
    }
    var = var->next;
  }
  PyErr_SetString(PyExc_NameError,"Unknown C global variable");
  return 1;
}

static PyTypeObject varlinktype = {
  PyObject_HEAD_INIT(0)
  0,                                  /* Number of items in variable part (ob_size) */
  (char *)"swigvarlink",              /* Type name (tp_name) */
  sizeof(swig_varlinkobject),         /* Basic size (tp_basicsize) */
  0,                                  /* Itemsize (tp_itemsize) */
  0,                                  /* Deallocator (tp_dealloc) */
  (printfunc) swig_varlink_print,     /* Print (tp_print) */
  (getattrfunc) swig_varlink_getattr, /* get attr (tp_getattr) */
  (setattrfunc) swig_varlink_setattr, /* Set attr (tp_setattr) */
  0,                                  /* tp_compare */
  (reprfunc) swig_varlink_repr,       /* tp_repr */
  0,                                  /* tp_as_number */
  0,                                  /* tp_as_sequence */
  0,                                  /* tp_as_mapping */
  0,                                  /* tp_hash */
  0,                                  /* tp_call */
  0,                                  /* tp_str */
  0,                                  /* tp_getattro */
  0,                                  /* tp_setattro */
  0,                                  /* tp_as_buffer */
  0,                                  /* tp_flags */
  0,                                  /* tp_doc */
  0,                                  /* tp_traverse */
  0,                                  /* tp_clear */
  0,                                  /* tp_richcompare */
  0,                                  /* tp_weaklistoffset */
#if PY_VERSION_HEX >= 0x02020000
  0,                                  /* tp_iter */
  0,                                  /* tp_iternext */
  0,                                  /* tp_methods */
  0,                                  /* tp_members */
  0,                                  /* tp_getset */
  0,                                  /* tp_base */
  0,                                  /* tp_dict */
  0,                                  /* tp_descr_get */
  0,                                  /* tp_descr_set */
  0,                                  /* tp_dictoffset */
  0,                                  /* tp_init */
  0,                                  /* tp_alloc */
  0,                                  /* tp_new */
  0,                                  /* tp_free */
  0,                                  /* tp_is_gc */
  0,                                  /* tp_bases */
  0,                                  /* tp_mro */
  0,                                  /* tp_cache */
  0,                                  /* tp_subclasses */
  0,                                  /* tp_weaklist */
#endif
#if PY_VERSION_HEX >= 0x02030000
  0,                                  /* tp_del */
#endif
#ifdef COUNT_ALLOCS
  /* these must be last */
  0,                                  /* tp_alloc */
  0,                                  /* tp_free */
  0,                                  /* tp_maxalloc */
  0,                                  /*  tp_next */
#endif
};

/* Create a variable linking object for use later */
static PyObject *
SWIG_Python_newvarlink(void) {
  swig_varlinkobject *result = 0;
  result = PyMem_NEW(swig_varlinkobject,1);
  varlinktype.ob_type = &PyType_Type;    /* Patch varlinktype into a PyType */
  result->ob_type = &varlinktype;
  result->vars = 0;
  result->ob_refcnt = 0;
  Py_XINCREF((PyObject *) result);
  return ((PyObject*) result);
}

static void
SWIG_Python_addvarlink(PyObject *p, char *name, PyObject *(*get_attr)(void), int (*set_attr)(PyObject *p)) {
  swig_varlinkobject *v;
  swig_globalvar *gv;
  v= (swig_varlinkobject *) p;
  gv = (swig_globalvar *) malloc(sizeof(swig_globalvar));
  gv->name = (char *) malloc(strlen(name)+1);
  strcpy(gv->name,name);
  gv->get_attr = get_attr;
  gv->set_attr = set_attr;
  gv->next = v->vars;
  v->vars = gv;
}

/* -----------------------------------------------------------------------------
 * errors manipulation
 * ----------------------------------------------------------------------------- */

static void
SWIG_Python_TypeError(const char *type, PyObject *obj)
{
  if (type) {
    if (!PyCObject_Check(obj)) {
      const char *otype = (obj ? obj->ob_type->tp_name : 0);
      if (otype) {
    PyObject *str = PyObject_Str(obj);
    const char *cstr = str ? PyString_AsString(str) : 0;
    if (cstr) {
      PyErr_Format(PyExc_TypeError, "a '%s' is expected, '%s(%s)' is received",
               type, otype, cstr);
    } else {
      PyErr_Format(PyExc_TypeError, "a '%s' is expected, '%s' is received",
               type, otype);
    }
    Py_DECREF(str);
    return;
      }
    } else {
      const char *otype = (char *) PyCObject_GetDesc(obj);
      if (otype) {
    PyErr_Format(PyExc_TypeError, "a '%s' is expected, 'PyCObject(%s)' is received",
             type, otype);
    return;
      }
    }
    PyErr_Format(PyExc_TypeError, "a '%s' is expected", type);

  } else {
    PyErr_Format(PyExc_TypeError, "unexpected type is received");
  }
}

static SWIGINLINE void
SWIG_Python_NullRef(const char *type)
{
  if (type) {
    PyErr_Format(PyExc_TypeError, "null reference of type '%s' was received",type);
  } else {
    PyErr_Format(PyExc_TypeError, "null reference was received");
  }
}

static int
SWIG_Python_AddErrMesg(const char* mesg, int infront)
{
  if (PyErr_Occurred()) {
    PyObject *type = 0;
    PyObject *value = 0;
    PyObject *traceback = 0;
    PyErr_Fetch(&type, &value, &traceback);
    if (value) {
      PyObject *old_str = PyObject_Str(value);
      Py_XINCREF(type);
      PyErr_Clear();
      if (infront) {
    PyErr_Format(type, "%s %s", mesg, PyString_AsString(old_str));
      } else {
    PyErr_Format(type, "%s %s", PyString_AsString(old_str), mesg);
      }
      Py_DECREF(old_str);
    }
    return 1;
  } else {
    return 0;
  }
}

static int
SWIG_Python_ArgFail(int argnum)
{
  if (PyErr_Occurred()) {
    /* add information about failing argument */
    char mesg[256];
    sprintf(mesg, "argument number %d:", argnum);
    return SWIG_Python_AddErrMesg(mesg, 1);
  } else {
    return 0;
  }
}


/* -----------------------------------------------------------------------------
 * pointers/data manipulation
 * ----------------------------------------------------------------------------- */

/* Convert a pointer value */
static int
SWIG_Python_ConvertPtr(PyObject *obj, void **ptr, swig_type_info *ty, int flags) {
  swig_type_info *tc;
  char  *c = 0;
  static PyObject *SWIG_this = 0;
  int    newref = 0;
  PyObject  *pyobj = 0;
  void *vptr;

  if (!obj) return 0;
  if (obj == Py_None) {
    *ptr = 0;
    return 0;
  }

#ifdef SWIG_COBJECT_TYPES
  if (!(PyCObject_Check(obj))) {
    if (!SWIG_this)
      SWIG_this = PyString_FromString("this");
    pyobj = obj;
    obj = PyObject_GetAttr(obj,SWIG_this);
    newref = 1;
    if (!obj) goto type_error;
    if (!PyCObject_Check(obj)) {
      Py_DECREF(obj);
      goto type_error;
    }
  }
  vptr = PyCObject_AsVoidPtr(obj);
  c = (char *) PyCObject_GetDesc(obj);
  if (newref) Py_DECREF(obj);
  goto type_check;
#else
  if (!(PyString_Check(obj))) {
    if (!SWIG_this)
      SWIG_this = PyString_FromString("this");
    pyobj = obj;
    obj = PyObject_GetAttr(obj,SWIG_this);
    newref = 1;
    if (!obj) goto type_error;
    if (!PyString_Check(obj)) {
      Py_DECREF(obj);
      goto type_error;
    }
  }
  c = PyString_AS_STRING(obj);
  /* Pointer values must start with leading underscore */
  if (*c != '_') {
    if (strcmp(c,"NULL") == 0) {
      if (newref) { Py_DECREF(obj); }
      *ptr = (void *) 0;
      return 0;
    } else {
      if (newref) { Py_DECREF(obj); }
      goto type_error;
    }
  }
  c++;
  c = SWIG_UnpackData(c,&vptr,sizeof(void *));
  if (newref) { Py_DECREF(obj); }
#endif

type_check:

  if (ty) {
    tc = SWIG_TypeCheck(c,ty);
    if (!tc) goto type_error;
    *ptr = SWIG_TypeCast(tc,vptr);
  }

  if ((pyobj) && (flags & SWIG_POINTER_DISOWN)) {
    PyObject_SetAttrString(pyobj,(char*)"thisown",Py_False);
  }
  return 0;

type_error:
  PyErr_Clear();
  if (pyobj && !obj) {
    obj = pyobj;
    if (PyCFunction_Check(obj)) {
      /* here we get the method pointer for callbacks */
      char *doc = (((PyCFunctionObject *)obj) -> m_ml -> ml_doc);
      c = doc ? strstr(doc, "swig_ptr: ") : 0;
      if (c) {
    c += 10;
    if (*c == '_') {
      c++;
      c = SWIG_UnpackData(c,&vptr,sizeof(void *));
      goto type_check;
    }
      }
    }
  }
  if (flags & SWIG_POINTER_EXCEPTION) {
    if (ty) {
      SWIG_Python_TypeError(SWIG_TypePrettyName(ty), obj);
    } else {
      SWIG_Python_TypeError("C/C++ pointer", obj);
    }
  }
  return -1;
}

/* Convert a pointer value, signal an exception on a type mismatch */
static void *
SWIG_Python_MustGetPtr(PyObject *obj, swig_type_info *ty, int argnum, int flags) {
  void *result;
  if (SWIG_Python_ConvertPtr(obj, &result, ty, flags) == -1) {
    PyErr_Clear();
    if (flags & SWIG_POINTER_EXCEPTION) {
      SWIG_Python_TypeError(SWIG_TypePrettyName(ty), obj);
      SWIG_Python_ArgFail(argnum);
    }
  }
  return result;
}

/* Convert a packed value value */
static int
SWIG_Python_ConvertPacked(PyObject *obj, void *ptr, size_t sz, swig_type_info *ty, int flags) {
  swig_type_info *tc;
  char  *c = 0;

  if ((!obj) || (!PyString_Check(obj))) goto type_error;
  c = PyString_AS_STRING(obj);
  /* Pointer values must start with leading underscore */
  if (*c != '_') goto type_error;
  c++;
  c = SWIG_UnpackData(c,ptr,sz);
  if (ty) {
    tc = SWIG_TypeCheck(c,ty);
    if (!tc) goto type_error;
  }
  return 0;

type_error:
  PyErr_Clear();
  if (flags & SWIG_POINTER_EXCEPTION) {
    if (ty) {
      SWIG_Python_TypeError(SWIG_TypePrettyName(ty), obj);
    } else {
      SWIG_Python_TypeError("C/C++ packed data", obj);
    }
  }
  return -1;
}

/* Create a new pointer std::string */
static char *
SWIG_Python_PointerStr(char *buff, void *ptr, const char *name, size_t bsz) {
  char *r = buff;
  if ((2*sizeof(void *) + 2) > bsz) return 0;
  *(r++) = '_';
  r = SWIG_PackData(r,&ptr,sizeof(void *));
  if (strlen(name) + 1 > (bsz - (r - buff))) return 0;
  strcpy(r,name);
  return buff;
}


/* Create a new pointer object */
static PyObject *
SWIG_Python_NewPointerObj(void *ptr, swig_type_info *type, int own) {
  PyObject *robj;
  if (!ptr) {
    Py_INCREF(Py_None);
    return Py_None;
  }
#ifdef SWIG_COBJECT_TYPES
  robj = PyCObject_FromVoidPtrAndDesc((void *) ptr, (char *) type->name, NULL);
#else
  {
    char result[1024];
    SWIG_Python_PointerStr(result, ptr, type->name, 1024);
    robj = PyString_FromString(result);
  }
#endif
  if (!robj || (robj == Py_None)) return robj;
  if (type->clientdata) {
    PyObject *inst;
    PyObject *args = Py_BuildValue((char*)"(O)", robj);
    Py_DECREF(robj);
    inst = PyObject_CallObject((PyObject *) type->clientdata, args);
    Py_DECREF(args);
    if (inst) {
      if (own) {
        PyObject_SetAttrString(inst,(char*)"thisown",Py_True);
      }
      robj = inst;
    }
  }
  return robj;
}

static PyObject *
SWIG_Python_NewPackedObj(void *ptr, size_t sz, swig_type_info *type) {
  char result[1024];
  char *r = result;
  if ((2*sz + 2 + strlen(type->name)) > 1024) return 0;
  *(r++) = '_';
  r = SWIG_PackData(r,ptr,sz);
  strcpy(r,type->name);
  return PyString_FromString(result);
}


/* -----------------------------------------------------------------------------
 * constants/methods manipulation
 * ----------------------------------------------------------------------------- */

/* Install Constants */
static void
SWIG_Python_InstallConstants(PyObject *d, swig_const_info constants[]) {
  int i;
  PyObject *obj;
  for (i = 0; constants[i].type; i++) {
    switch(constants[i].type) {
    case SWIG_PY_INT:
      obj = PyInt_FromLong(constants[i].lvalue);
      break;
    case SWIG_PY_FLOAT:
      obj = PyFloat_FromDouble(constants[i].dvalue);
      break;
    case SWIG_PY_STRING:
      if (constants[i].pvalue) {
    obj = PyString_FromString((char *) constants[i].pvalue);
      } else {
    Py_INCREF(Py_None);
    obj = Py_None;
      }
      break;
    case SWIG_PY_POINTER:
      obj = SWIG_NewPointerObj(constants[i].pvalue, *(constants[i]).ptype,0);
      break;
    case SWIG_PY_BINARY:
      obj = SWIG_NewPackedObj(constants[i].pvalue, constants[i].lvalue, *(constants[i].ptype));
      break;
    default:
      obj = 0;
      break;
    }
    if (obj) {
      PyDict_SetItemString(d,constants[i].name,obj);
      Py_DECREF(obj);
    }
  }
}

/* Fix SwigMethods to carry the callback ptrs when needed */
static void
SWIG_Python_FixMethods(PyMethodDef *methods,
               swig_const_info *const_table,
               swig_type_info **types,
               swig_type_info **types_initial) {
  int i;
  for (i = 0; methods[i].ml_name; ++i) {
    char *c = methods[i].ml_doc;
    if (c && (c = strstr(c, "swig_ptr: "))) {
      int j;
      swig_const_info *ci = 0;
      char *name = c + 10;
      for (j = 0; const_table[j].type; j++) {
    if (strncmp(const_table[j].name, name,
            strlen(const_table[j].name)) == 0) {
      ci = &(const_table[j]);
      break;
    }
      }
      if (ci) {
    size_t shift = (ci->ptype) - types;
    swig_type_info *ty = types_initial[shift];
    size_t ldoc = (c - methods[i].ml_doc);
    size_t lptr = strlen(ty->name)+2*sizeof(void*)+2;
    char *ndoc = (char*)malloc(ldoc + lptr + 10);
    char *buff = ndoc;
    void *ptr = (ci->type == SWIG_PY_POINTER) ? ci->pvalue: (void *)(ci->lvalue);
    strncpy(buff, methods[i].ml_doc, ldoc);
    buff += ldoc;
    strncpy(buff, "swig_ptr: ", 10);
    buff += 10;
    SWIG_Python_PointerStr(buff, ptr, ty->name, lptr);
    methods[i].ml_doc = ndoc;
      }
    }
  }
}


/* -----------------------------------------------------------------------------
 * Lookup type pointer
 * ----------------------------------------------------------------------------- */
#if PY_MAJOR_VERSION < 2
/* PyModule_AddObject function was introduced in Python 2.0.  The following function
is copied out of Python/modsupport.c in python version 2.3.4 */
static int
PyModule_AddObject(PyObject *m, char *name, PyObject *o)
{
    PyObject *dict;
    if (!PyModule_Check(m)) {
        PyErr_SetString(PyExc_TypeError,
                "PyModule_AddObject() needs module as first arg");
        return -1;
    }
    if (!o) {
        PyErr_SetString(PyExc_TypeError,
                "PyModule_AddObject() needs non-NULL value");
        return -1;
    }

    dict = PyModule_GetDict(m);
    if (dict == NULL) {
        /* Internal error -- modules must have a dict! */
        PyErr_Format(PyExc_SystemError, "module '%s' has no __dict__",
                 PyModule_GetName(m));
        return -1;
    }
    if (PyDict_SetItemString(dict, name, o))
        return -1;
    Py_DECREF(o);
    return 0;
}
#endif
static PyMethodDef swig_empty_runtime_method_table[] = {
    {NULL, NULL, 0, NULL}        /* Sentinel */
};

static void
SWIG_Python_LookupTypePointer(swig_type_info ***type_list_handle) {
  PyObject *module, *pointer;
  void *type_pointer;

  /* first check if module already created */
  type_pointer = PyCObject_Import((char*)"swig_runtime_data" SWIG_RUNTIME_VERSION, (char*)"type_pointer" SWIG_TYPE_TABLE_NAME);
  if (type_pointer) {
    *type_list_handle = (swig_type_info **) type_pointer;
  } else {
    PyErr_Clear();
    /* create a new module and variable */
    module = Py_InitModule((char*)"swig_runtime_data" SWIG_RUNTIME_VERSION, swig_empty_runtime_method_table);
    pointer = PyCObject_FromVoidPtr((void *) (*type_list_handle), NULL);
    if (pointer && module) {
      PyModule_AddObject(module, (char*)"type_pointer" SWIG_TYPE_TABLE_NAME, pointer);
    }
  }
}

#ifdef __cplusplus
}
#endif


/* -------- TYPES TABLE (BEGIN) -------- */

#define  SWIGTYPE_p_LOCA__ParameterVector swig_types[0]
#define  SWIGTYPE_std__size_t swig_types[1]
#define  SWIGTYPE_size_t swig_types[2]
#define  SWIGTYPE_p_double swig_types[3]
#define  SWIGTYPE_p_Teuchos__RefCountPtrTLOCA__Abstract__Factory_t swig_types[4]
#define  SWIGTYPE_p_NOX__Parameter__List swig_types[5]
#define  SWIGTYPE_p_vectorTdouble_t swig_types[6]
#define  SWIGTYPE_p_char swig_types[7]
#define  SWIGTYPE_p_LOCA__Continuation__AbstractGroup swig_types[8]
#define  SWIGTYPE_p_ostream swig_types[9]
#define  SWIGTYPE_std__ptrdiff_t swig_types[10]
#define  SWIGTYPE_ptrdiff_t swig_types[11]
#define  SWIGTYPE_p_vectorTstd__string_t swig_types[12]
#define  SWIGTYPE_p_Utils swig_types[13]
#define  SWIGTYPE_p_NOX__Solver__Generic swig_types[14]
#define  SWIGTYPE_p_LOCA__Stepper swig_types[15]
#define  SWIGTYPE_p_NOX__StatusTest__Generic swig_types[16]
#define  SWIGTYPE_p_LOCA__Abstract__Iterator swig_types[17]
static swig_type_info *swig_types[19];

/* -------- TYPES TABLE (END) -------- */


/*-----------------------------------------------
              @(target):= _TopLevel.so
  ------------------------------------------------*/
#define SWIG_init    init_TopLevel

#define SWIG_name    "_TopLevel"

// LOCA includes
#include "LOCA_Stepper.H"
#include "LOCA_Parameter_Vector.H"
#include "Utils_enums.H"


#include <string>


  /*@/usr/local/swig-1.3.23/share/swig/1.3.23/python/pymacros.swg,66,SWIG_define@*/
#define SWIG_From_int PyInt_FromLong
/*@@*/


SWIGINTERNSHORT PyObject*
  SWIG_From_bool(bool value)
{
  PyObject *obj = value ? Py_True : Py_False;
  Py_INCREF(obj);
  return obj;
}


/* returns SWIG_OLDOBJ if the input is a raw char*, SWIG_PYSTR if is a PyString */
SWIGINTERN int
SWIG_AsCharPtrAndSize(PyObject *obj, char** cptr, size_t* psize)
{
  static swig_type_info* pchar_info = 0;
  char* vptr = 0;
  if (!pchar_info) pchar_info = SWIG_TypeQuery("char *");
  if (SWIG_ConvertPtr(obj, (void**)&vptr, pchar_info, 0) != -1) {
    if (cptr) *cptr = vptr;
    if (psize) *psize = vptr ? (strlen(vptr) + 1) : 0;
    return SWIG_OLDOBJ;
  } else {
    PyErr_Clear();
    if (PyString_Check(obj)) {
      if (cptr) {
    *cptr = PyString_AS_STRING(obj);
    if (psize) {
      *psize = PyString_GET_SIZE(obj) + 1;
    }
      }
      return SWIG_PYSTR;
    }
  }
  if (cptr) {
    SWIG_type_error("char *", obj);
  }
  return 0;
}


  SWIGINTERN int
    SWIG_AsPtr_std_string(PyObject* obj, std::string **val)
    {
      static swig_type_info* std::string_info = SWIG_TypeQuery("std::string *");
      std::string *vptr;
      if (SWIG_ConvertPtr(obj, (void**)&vptr, std::string_info, 0) != -1) {
    if (val) *val = vptr;
    return SWIG_OLDOBJ;
      } else {
    PyErr_Clear();
    char* buf = 0 ; size_t size = 0;
    if (SWIG_AsCharPtrAndSize(obj, &buf, &size)) {
      if (buf) {
        if (val) *val = new std::string(buf, size - 1);
        return SWIG_NEWOBJ;
      }
    } else {
      PyErr_Clear();
    }
    if (val) {
      PyErr_SetString(PyExc_TypeError,"a std::string is expected");
    }
    return 0;
      }
    }


SWIGINTERN int
  SWIG_AsVal_double(PyObject *obj, double *val)
{
  if (PyFloat_Check(obj)) {
    if (val) *val = PyFloat_AS_DOUBLE(obj);
    return 1;
  }
  if (PyInt_Check(obj)) {
    if (val) *val = PyInt_AS_LONG(obj);
    return 1;
  }
  if (PyLong_Check(obj)) {
    double v = PyLong_AsDouble(obj);
    if (!PyErr_Occurred()) {
      if (val) *val = v;
      return 1;
    } else {
      if (!val) PyErr_Clear();
      return 0;
    }
  }
  if (val) {
    SWIG_type_error("double", obj);
  }
  return 0;
}


SWIGINTERNSHORT double
SWIG_As_double(PyObject* obj)
{
  double v;
  if (!SWIG_AsVal_double(obj, &v)) {
    /*
      this is needed to make valgrind/purify happier.
     */
    memset((void*)&v, 0, sizeof(double));
  }
  return v;
}


SWIGINTERNSHORT int
SWIG_Check_double(PyObject* obj)
{
  return SWIG_AsVal_double(obj, (double*)0);
}


#include <limits.h>


SWIGINTERNSHORT int
  SWIG_CheckUnsignedLongInRange(unsigned long value,
                unsigned long max_value,
                const char *errmsg)
{
  if (value > max_value) {
    if (errmsg) {
      PyErr_Format(PyExc_OverflowError,
           "value %lu is greater than '%s' minimum %lu",
           value, errmsg, max_value);
    }
    return 0;
  }
  return 1;
 }


SWIGINTERN int
  SWIG_AsVal_unsigned_SS_long(PyObject *obj, unsigned long *val)
{
  if (PyInt_Check(obj)) {
    long v = PyInt_AS_LONG(obj);
    if (v >= 0) {
      if (val) *val = v;
      return 1;
    }
  }
  if (PyLong_Check(obj)) {
    unsigned long v = PyLong_AsUnsignedLong(obj);
    if (!PyErr_Occurred()) {
      if (val) *val = v;
      return 1;
    } else {
      if (!val) PyErr_Clear();
      return 0;
    }
  }
  if (val) {
    SWIG_type_error("unsigned long", obj);
  }
  return 0;
}


#if UINT_MAX != ULONG_MAX
SWIGINTERN int
  SWIG_AsVal_unsigned_SS_int(PyObject *obj, unsigned int *val)
{
  const char* errmsg = val ? "unsigned int" : (char*)0;
  unsigned long v;
  if (SWIG_AsVal_unsigned_SS_long(obj, &v)) {
    if (SWIG_CheckUnsignedLongInRange(v, INT_MAX, errmsg)) {
      if (val) *val = (unsigned int)(v);
      return 1;
    }
  } else {
    PyErr_Clear();
  }
  if (val) {
    SWIG_type_error(errmsg, obj);
  }
  return 0;
}
#else
SWIGINTERNSHORT unsigned int
  SWIG_AsVal_unsigned_SS_int(PyObject *obj, unsigned int *val)
{
  return SWIG_AsVal_unsigned_SS_long(obj,(unsigned long *)val);
}
#endif


SWIGINTERNSHORT unsigned int
SWIG_As_unsigned_SS_int(PyObject* obj)
{
  unsigned int v;
  if (!SWIG_AsVal_unsigned_SS_int(obj, &v)) {
    /*
      this is needed to make valgrind/purify happier.
     */
    memset((void*)&v, 0, sizeof(unsigned int));
  }
  return v;
}


SWIGINTERNSHORT int
SWIG_Check_unsigned_SS_int(PyObject* obj)
{
  return SWIG_AsVal_unsigned_SS_int(obj, (unsigned int*)0);
}


  /*@/usr/local/swig-1.3.23/share/swig/1.3.23/python/pymacros.swg,66,SWIG_define@*/
#define SWIG_From_double PyFloat_FromDouble
/*@@*/


SWIGINTERNSHORT PyObject *
SWIG_FromCharArray(const char* carray, size_t size)
{
  if (size > INT_MAX) {
    return Py_None;
  } else {
    return PyString_FromStringAndSize(carray, (int)(size));
  }
}


SWIGINTERNSHORT PyObject*
  SWIG_From_std_string(const std::string& s)
  {
    return SWIG_FromCharArray(s.data(), s.size());
  }

#ifdef __cplusplus
extern "C" {
#endif
static PyObject *_wrap_delete_Iterator(PyObject *, PyObject *args) {
    PyObject *resultobj;
    LOCA::Abstract::Iterator *arg1 = (LOCA::Abstract::Iterator *) 0 ;
    PyObject * obj0 = 0 ;

    if(!PyArg_ParseTuple(args,(char *)"O:delete_Iterator",&obj0)) goto fail;
    SWIG_Python_ConvertPtr(obj0, (void **)&arg1, SWIGTYPE_p_LOCA__Abstract__Iterator, SWIG_POINTER_EXCEPTION | 0);
    if (SWIG_arg_fail(1)) SWIG_fail;
    delete arg1;

    Py_INCREF(Py_None); resultobj = Py_None;
    return resultobj;
    fail:
    return NULL;
}


static PyObject *_wrap_Iterator_resetIterator(PyObject *, PyObject *args) {
    PyObject *resultobj;
    LOCA::Abstract::Iterator *arg1 = (LOCA::Abstract::Iterator *) 0 ;
    NOX::Parameter::List *arg2 = 0 ;
    bool result;
    PyObject * obj0 = 0 ;
    PyObject * obj1 = 0 ;

    if(!PyArg_ParseTuple(args,(char *)"OO:Iterator_resetIterator",&obj0,&obj1)) goto fail;
    SWIG_Python_ConvertPtr(obj0, (void **)&arg1, SWIGTYPE_p_LOCA__Abstract__Iterator, SWIG_POINTER_EXCEPTION | 0);
    if (SWIG_arg_fail(1)) SWIG_fail;
    {
        SWIG_Python_ConvertPtr(obj1, (void **)&arg2, SWIGTYPE_p_NOX__Parameter__List, SWIG_POINTER_EXCEPTION | 0);
        if (SWIG_arg_fail(2)) SWIG_fail;
        if (arg2 == NULL) {
            SWIG_null_ref("NOX::Parameter::List");
        }
        if (SWIG_arg_fail(2)) SWIG_fail;
    }
    result = (bool)(arg1)->resetIterator(*arg2);

    {
        resultobj = SWIG_From_bool((bool)(result));
    }
    return resultobj;
    fail:
    return NULL;
}


static PyObject *_wrap_Iterator_getIteratorStatus(PyObject *, PyObject *args) {
    PyObject *resultobj;
    LOCA::Abstract::Iterator *arg1 = (LOCA::Abstract::Iterator *) 0 ;
    int result;
    PyObject * obj0 = 0 ;

    if(!PyArg_ParseTuple(args,(char *)"O:Iterator_getIteratorStatus",&obj0)) goto fail;
    SWIG_Python_ConvertPtr(obj0, (void **)&arg1, SWIGTYPE_p_LOCA__Abstract__Iterator, SWIG_POINTER_EXCEPTION | 0);
    if (SWIG_arg_fail(1)) SWIG_fail;
    result = (int)((LOCA::Abstract::Iterator const *)arg1)->getIteratorStatus();

    resultobj = SWIG_From_int((result));
    return resultobj;
    fail:
    return NULL;
}


static PyObject *_wrap_Iterator_getStepNumber(PyObject *, PyObject *args) {
    PyObject *resultobj;
    LOCA::Abstract::Iterator *arg1 = (LOCA::Abstract::Iterator *) 0 ;
    int result;
    PyObject * obj0 = 0 ;

    if(!PyArg_ParseTuple(args,(char *)"O:Iterator_getStepNumber",&obj0)) goto fail;
    SWIG_Python_ConvertPtr(obj0, (void **)&arg1, SWIGTYPE_p_LOCA__Abstract__Iterator, SWIG_POINTER_EXCEPTION | 0);
    if (SWIG_arg_fail(1)) SWIG_fail;
    result = (int)((LOCA::Abstract::Iterator const *)arg1)->getStepNumber();

    {
        resultobj = SWIG_From_int((int)(result));
    }
    return resultobj;
    fail:
    return NULL;
}


static PyObject *_wrap_Iterator_getNumFailedSteps(PyObject *, PyObject *args) {
    PyObject *resultobj;
    LOCA::Abstract::Iterator *arg1 = (LOCA::Abstract::Iterator *) 0 ;
    int result;
    PyObject * obj0 = 0 ;

    if(!PyArg_ParseTuple(args,(char *)"O:Iterator_getNumFailedSteps",&obj0)) goto fail;
    SWIG_Python_ConvertPtr(obj0, (void **)&arg1, SWIGTYPE_p_LOCA__Abstract__Iterator, SWIG_POINTER_EXCEPTION | 0);
    if (SWIG_arg_fail(1)) SWIG_fail;
    result = (int)((LOCA::Abstract::Iterator const *)arg1)->getNumFailedSteps();

    {
        resultobj = SWIG_From_int((int)(result));
    }
    return resultobj;
    fail:
    return NULL;
}


static PyObject *_wrap_Iterator_getNumTotalSteps(PyObject *, PyObject *args) {
    PyObject *resultobj;
    LOCA::Abstract::Iterator *arg1 = (LOCA::Abstract::Iterator *) 0 ;
    int result;
    PyObject * obj0 = 0 ;

    if(!PyArg_ParseTuple(args,(char *)"O:Iterator_getNumTotalSteps",&obj0)) goto fail;
    SWIG_Python_ConvertPtr(obj0, (void **)&arg1, SWIGTYPE_p_LOCA__Abstract__Iterator, SWIG_POINTER_EXCEPTION | 0);
    if (SWIG_arg_fail(1)) SWIG_fail;
    result = (int)((LOCA::Abstract::Iterator const *)arg1)->getNumTotalSteps();

    {
        resultobj = SWIG_From_int((int)(result));
    }
    return resultobj;
    fail:
    return NULL;
}


static PyObject *_wrap_Iterator_run(PyObject *, PyObject *args) {
    PyObject *resultobj;
    LOCA::Abstract::Iterator *arg1 = (LOCA::Abstract::Iterator *) 0 ;
    int result;
    PyObject * obj0 = 0 ;

    if(!PyArg_ParseTuple(args,(char *)"O:Iterator_run",&obj0)) goto fail;
    SWIG_Python_ConvertPtr(obj0, (void **)&arg1, SWIGTYPE_p_LOCA__Abstract__Iterator, SWIG_POINTER_EXCEPTION | 0);
    if (SWIG_arg_fail(1)) SWIG_fail;
    result = (int)(arg1)->run();

    resultobj = SWIG_From_int((result));
    return resultobj;
    fail:
    return NULL;
}


static PyObject * Iterator_swigregister(PyObject *, PyObject *args) {
    PyObject *obj;
    if (!PyArg_ParseTuple(args,(char*)"O", &obj)) return NULL;
    SWIG_TypeClientData(SWIGTYPE_p_LOCA__Abstract__Iterator, obj);
    Py_INCREF(obj);
    return Py_BuildValue((char *)"");
}
static PyObject *_wrap_new_Stepper__SWIG_0(PyObject *, PyObject *args) {
    PyObject *resultobj;
    LOCA::Continuation::AbstractGroup *arg1 = 0 ;
    NOX::StatusTest::Generic *arg2 = 0 ;
    NOX::Parameter::List *arg3 = 0 ;
    LOCA::Stepper *result;
    PyObject * obj0 = 0 ;
    PyObject * obj1 = 0 ;
    PyObject * obj2 = 0 ;

    if(!PyArg_ParseTuple(args,(char *)"OOO:new_Stepper",&obj0,&obj1,&obj2)) goto fail;
    {
        SWIG_Python_ConvertPtr(obj0, (void **)&arg1, SWIGTYPE_p_LOCA__Continuation__AbstractGroup, SWIG_POINTER_EXCEPTION | 0);
        if (SWIG_arg_fail(1)) SWIG_fail;
        if (arg1 == NULL) {
            SWIG_null_ref("LOCA::Continuation::AbstractGroup");
        }
        if (SWIG_arg_fail(1)) SWIG_fail;
    }
    {
        SWIG_Python_ConvertPtr(obj1, (void **)&arg2, SWIGTYPE_p_NOX__StatusTest__Generic, SWIG_POINTER_EXCEPTION | 0);
        if (SWIG_arg_fail(2)) SWIG_fail;
        if (arg2 == NULL) {
            SWIG_null_ref("NOX::StatusTest::Generic");
        }
        if (SWIG_arg_fail(2)) SWIG_fail;
    }
    {
        SWIG_Python_ConvertPtr(obj2, (void **)&arg3, SWIGTYPE_p_NOX__Parameter__List, SWIG_POINTER_EXCEPTION | 0);
        if (SWIG_arg_fail(3)) SWIG_fail;
        if (arg3 == NULL) {
            SWIG_null_ref("NOX::Parameter::List");
        }
        if (SWIG_arg_fail(3)) SWIG_fail;
    }
    result = (LOCA::Stepper *)new LOCA::Stepper(*arg1,*arg2,*arg3);

    resultobj = SWIG_NewPointerObj((void*)(result), SWIGTYPE_p_LOCA__Stepper, 1);
    return resultobj;
    fail:
    return NULL;
}


static PyObject *_wrap_new_Stepper__SWIG_1(PyObject *, PyObject *args) {
    PyObject *resultobj;
    LOCA::Continuation::AbstractGroup *arg1 = 0 ;
    NOX::StatusTest::Generic *arg2 = 0 ;
    NOX::Parameter::List *arg3 = 0 ;
    Teuchos::RCP<LOCA::Abstract::Factory > *arg4 = 0 ;
    LOCA::Stepper *result;
    PyObject * obj0 = 0 ;
    PyObject * obj1 = 0 ;
    PyObject * obj2 = 0 ;
    PyObject * obj3 = 0 ;

    if(!PyArg_ParseTuple(args,(char *)"OOOO:new_Stepper",&obj0,&obj1,&obj2,&obj3)) goto fail;
    {
        SWIG_Python_ConvertPtr(obj0, (void **)&arg1, SWIGTYPE_p_LOCA__Continuation__AbstractGroup, SWIG_POINTER_EXCEPTION | 0);
        if (SWIG_arg_fail(1)) SWIG_fail;
        if (arg1 == NULL) {
            SWIG_null_ref("LOCA::Continuation::AbstractGroup");
        }
        if (SWIG_arg_fail(1)) SWIG_fail;
    }
    {
        SWIG_Python_ConvertPtr(obj1, (void **)&arg2, SWIGTYPE_p_NOX__StatusTest__Generic, SWIG_POINTER_EXCEPTION | 0);
        if (SWIG_arg_fail(2)) SWIG_fail;
        if (arg2 == NULL) {
            SWIG_null_ref("NOX::StatusTest::Generic");
        }
        if (SWIG_arg_fail(2)) SWIG_fail;
    }
    {
        SWIG_Python_ConvertPtr(obj2, (void **)&arg3, SWIGTYPE_p_NOX__Parameter__List, SWIG_POINTER_EXCEPTION | 0);
        if (SWIG_arg_fail(3)) SWIG_fail;
        if (arg3 == NULL) {
            SWIG_null_ref("NOX::Parameter::List");
        }
        if (SWIG_arg_fail(3)) SWIG_fail;
    }
    {
        SWIG_Python_ConvertPtr(obj3, (void **)&arg4, SWIGTYPE_p_Teuchos__RefCountPtrTLOCA__Abstract__Factory_t, SWIG_POINTER_EXCEPTION | 0);
        if (SWIG_arg_fail(4)) SWIG_fail;
        if (arg4 == NULL) {
            SWIG_null_ref("Teuchos::RCP<LOCA::Abstract::Factory >");
        }
        if (SWIG_arg_fail(4)) SWIG_fail;
    }
    result = (LOCA::Stepper *)new LOCA::Stepper(*arg1,*arg2,*arg3,(Teuchos::RCP<LOCA::Abstract::Factory > const &)*arg4);

    resultobj = SWIG_NewPointerObj((void*)(result), SWIGTYPE_p_LOCA__Stepper, 1);
    return resultobj;
    fail:
    return NULL;
}


static PyObject *_wrap_new_Stepper(PyObject *self, PyObject *args) {
    int argc;
    PyObject *argv[5];
    int ii;

    argc = PyObject_Length(args);
    for (ii = 0; (ii < argc) && (ii < 4); ii++) {
        argv[ii] = PyTuple_GetItem(args,ii);
    }
    if (argc == 3) {
        int _v;
        {
            void *ptr = 0;
            if (SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_LOCA__Continuation__AbstractGroup, 0) == -1) {
                _v = 0;
                PyErr_Clear();
            } else {
                _v = (ptr != 0);
            }
        }
        if (_v) {
            {
                void *ptr = 0;
                if (SWIG_ConvertPtr(argv[1], &ptr, SWIGTYPE_p_NOX__StatusTest__Generic, 0) == -1) {
                    _v = 0;
                    PyErr_Clear();
                } else {
                    _v = (ptr != 0);
                }
            }
            if (_v) {
                {
                    void *ptr = 0;
                    if (SWIG_ConvertPtr(argv[2], &ptr, SWIGTYPE_p_NOX__Parameter__List, 0) == -1) {
                        _v = 0;
                        PyErr_Clear();
                    } else {
                        _v = (ptr != 0);
                    }
                }
                if (_v) {
                    return _wrap_new_Stepper__SWIG_0(self,args);
                }
            }
        }
    }
    if (argc == 4) {
        int _v;
        {
            void *ptr = 0;
            if (SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_LOCA__Continuation__AbstractGroup, 0) == -1) {
                _v = 0;
                PyErr_Clear();
            } else {
                _v = (ptr != 0);
            }
        }
        if (_v) {
            {
                void *ptr = 0;
                if (SWIG_ConvertPtr(argv[1], &ptr, SWIGTYPE_p_NOX__StatusTest__Generic, 0) == -1) {
                    _v = 0;
                    PyErr_Clear();
                } else {
                    _v = (ptr != 0);
                }
            }
            if (_v) {
                {
                    void *ptr = 0;
                    if (SWIG_ConvertPtr(argv[2], &ptr, SWIGTYPE_p_NOX__Parameter__List, 0) == -1) {
                        _v = 0;
                        PyErr_Clear();
                    } else {
                        _v = (ptr != 0);
                    }
                }
                if (_v) {
                    {
                        void *ptr = 0;
                        if (SWIG_ConvertPtr(argv[3], &ptr, SWIGTYPE_p_Teuchos__RefCountPtrTLOCA__Abstract__Factory_t, 0) == -1) {
                            _v = 0;
                            PyErr_Clear();
                        } else {
                            _v = (ptr != 0);
                        }
                    }
                    if (_v) {
                        return _wrap_new_Stepper__SWIG_1(self,args);
                    }
                }
            }
        }
    }

    PyErr_SetString(PyExc_NotImplementedError,"No matching function for overloaded 'new_Stepper'");
    return NULL;
}


static PyObject *_wrap_delete_Stepper(PyObject *, PyObject *args) {
    PyObject *resultobj;
    LOCA::Stepper *arg1 = (LOCA::Stepper *) 0 ;
    PyObject * obj0 = 0 ;

    if(!PyArg_ParseTuple(args,(char *)"O:delete_Stepper",&obj0)) goto fail;
    SWIG_Python_ConvertPtr(obj0, (void **)&arg1, SWIGTYPE_p_LOCA__Stepper, SWIG_POINTER_EXCEPTION | 0);
    if (SWIG_arg_fail(1)) SWIG_fail;
    delete arg1;

    Py_INCREF(Py_None); resultobj = Py_None;
    return resultobj;
    fail:
    return NULL;
}


static PyObject *_wrap_Stepper_reset(PyObject *, PyObject *args) {
    PyObject *resultobj;
    LOCA::Stepper *arg1 = (LOCA::Stepper *) 0 ;
    LOCA::Continuation::AbstractGroup *arg2 = 0 ;
    NOX::StatusTest::Generic *arg3 = 0 ;
    NOX::Parameter::List *arg4 = 0 ;
    bool result;
    PyObject * obj0 = 0 ;
    PyObject * obj1 = 0 ;
    PyObject * obj2 = 0 ;
    PyObject * obj3 = 0 ;

    if(!PyArg_ParseTuple(args,(char *)"OOOO:Stepper_reset",&obj0,&obj1,&obj2,&obj3)) goto fail;
    SWIG_Python_ConvertPtr(obj0, (void **)&arg1, SWIGTYPE_p_LOCA__Stepper, SWIG_POINTER_EXCEPTION | 0);
    if (SWIG_arg_fail(1)) SWIG_fail;
    {
        SWIG_Python_ConvertPtr(obj1, (void **)&arg2, SWIGTYPE_p_LOCA__Continuation__AbstractGroup, SWIG_POINTER_EXCEPTION | 0);
        if (SWIG_arg_fail(2)) SWIG_fail;
        if (arg2 == NULL) {
            SWIG_null_ref("LOCA::Continuation::AbstractGroup");
        }
        if (SWIG_arg_fail(2)) SWIG_fail;
    }
    {
        SWIG_Python_ConvertPtr(obj2, (void **)&arg3, SWIGTYPE_p_NOX__StatusTest__Generic, SWIG_POINTER_EXCEPTION | 0);
        if (SWIG_arg_fail(3)) SWIG_fail;
        if (arg3 == NULL) {
            SWIG_null_ref("NOX::StatusTest::Generic");
        }
        if (SWIG_arg_fail(3)) SWIG_fail;
    }
    {
        SWIG_Python_ConvertPtr(obj3, (void **)&arg4, SWIGTYPE_p_NOX__Parameter__List, SWIG_POINTER_EXCEPTION | 0);
        if (SWIG_arg_fail(4)) SWIG_fail;
        if (arg4 == NULL) {
            SWIG_null_ref("NOX::Parameter::List");
        }
        if (SWIG_arg_fail(4)) SWIG_fail;
    }
    result = (bool)(arg1)->reset(*arg2,*arg3,*arg4);

    {
        resultobj = SWIG_From_bool((bool)(result));
    }
    return resultobj;
    fail:
    return NULL;
}


static PyObject *_wrap_Stepper_getSolutionGroup(PyObject *, PyObject *args) {
    PyObject *resultobj;
    LOCA::Stepper *arg1 = (LOCA::Stepper *) 0 ;
    LOCA::Continuation::AbstractGroup *result;
    PyObject * obj0 = 0 ;

    if(!PyArg_ParseTuple(args,(char *)"O:Stepper_getSolutionGroup",&obj0)) goto fail;
    SWIG_Python_ConvertPtr(obj0, (void **)&arg1, SWIGTYPE_p_LOCA__Stepper, SWIG_POINTER_EXCEPTION | 0);
    if (SWIG_arg_fail(1)) SWIG_fail;
    {
        LOCA::Continuation::AbstractGroup &_result_ref = (arg1)->getSolutionGroup();
        result = (LOCA::Continuation::AbstractGroup *) &_result_ref;
    }

    resultobj = SWIG_NewPointerObj((void*)(result), SWIGTYPE_p_LOCA__Continuation__AbstractGroup, 0);
    return resultobj;
    fail:
    return NULL;
}


static PyObject *_wrap_Stepper_getBifurcationGroup(PyObject *, PyObject *args) {
    PyObject *resultobj;
    LOCA::Stepper *arg1 = (LOCA::Stepper *) 0 ;
    LOCA::Continuation::AbstractGroup *result;
    PyObject * obj0 = 0 ;

    if(!PyArg_ParseTuple(args,(char *)"O:Stepper_getBifurcationGroup",&obj0)) goto fail;
    SWIG_Python_ConvertPtr(obj0, (void **)&arg1, SWIGTYPE_p_LOCA__Stepper, SWIG_POINTER_EXCEPTION | 0);
    if (SWIG_arg_fail(1)) SWIG_fail;
    {
        LOCA::Continuation::AbstractGroup &_result_ref = (arg1)->getBifurcationGroup();
        result = (LOCA::Continuation::AbstractGroup *) &_result_ref;
    }

    resultobj = SWIG_NewPointerObj((void*)(result), SWIGTYPE_p_LOCA__Continuation__AbstractGroup, 0);
    return resultobj;
    fail:
    return NULL;
}


static PyObject *_wrap_Stepper_getParameterList(PyObject *, PyObject *args) {
    PyObject *resultobj;
    LOCA::Stepper *arg1 = (LOCA::Stepper *) 0 ;
    NOX::Parameter::List *result;
    PyObject * obj0 = 0 ;

    if(!PyArg_ParseTuple(args,(char *)"O:Stepper_getParameterList",&obj0)) goto fail;
    SWIG_Python_ConvertPtr(obj0, (void **)&arg1, SWIGTYPE_p_LOCA__Stepper, SWIG_POINTER_EXCEPTION | 0);
    if (SWIG_arg_fail(1)) SWIG_fail;
    {
        NOX::Parameter::List const &_result_ref = ((LOCA::Stepper const *)arg1)->getParameterList();
        result = (NOX::Parameter::List *) &_result_ref;
    }

    resultobj = SWIG_NewPointerObj((void*)(result), SWIGTYPE_p_NOX__Parameter__List, 0);
    return resultobj;
    fail:
    return NULL;
}


static PyObject *_wrap_Stepper_getSolver(PyObject *, PyObject *args) {
    PyObject *resultobj;
    LOCA::Stepper *arg1 = (LOCA::Stepper *) 0 ;
    NOX::Solver::Generic *result;
    PyObject * obj0 = 0 ;

    if(!PyArg_ParseTuple(args,(char *)"O:Stepper_getSolver",&obj0)) goto fail;
    SWIG_Python_ConvertPtr(obj0, (void **)&arg1, SWIGTYPE_p_LOCA__Stepper, SWIG_POINTER_EXCEPTION | 0);
    if (SWIG_arg_fail(1)) SWIG_fail;
    {
        NOX::Solver::Generic const &_result_ref = ((LOCA::Stepper const *)arg1)->getSolver();
        result = (NOX::Solver::Generic *) &_result_ref;
    }

    resultobj = SWIG_NewPointerObj((void*)(result), SWIGTYPE_p_NOX__Solver__Generic, 0);
    return resultobj;
    fail:
    return NULL;
}


static PyObject * Stepper_swigregister(PyObject *, PyObject *args) {
    PyObject *obj;
    if (!PyArg_ParseTuple(args,(char*)"O", &obj)) return NULL;
    SWIG_TypeClientData(SWIGTYPE_p_LOCA__Stepper, obj);
    Py_INCREF(obj);
    return Py_BuildValue((char *)"");
}
static PyObject *_wrap_new_ParameterVector__SWIG_0(PyObject *, PyObject *args) {
    PyObject *resultobj;
    LOCA::ParameterVector *result;

    if(!PyArg_ParseTuple(args,(char *)":new_ParameterVector")) goto fail;
    result = (LOCA::ParameterVector *)new LOCA::ParameterVector();

    resultobj = SWIG_NewPointerObj((void*)(result), SWIGTYPE_p_LOCA__ParameterVector, 1);
    return resultobj;
    fail:
    return NULL;
}


static PyObject *_wrap_new_ParameterVector__SWIG_1(PyObject *, PyObject *args) {
    PyObject *resultobj;
    LOCA::ParameterVector *arg1 = 0 ;
    LOCA::ParameterVector *result;
    PyObject * obj0 = 0 ;

    if(!PyArg_ParseTuple(args,(char *)"O:new_ParameterVector",&obj0)) goto fail;
    {
        SWIG_Python_ConvertPtr(obj0, (void **)&arg1, SWIGTYPE_p_LOCA__ParameterVector, SWIG_POINTER_EXCEPTION | 0);
        if (SWIG_arg_fail(1)) SWIG_fail;
        if (arg1 == NULL) {
            SWIG_null_ref("LOCA::ParameterVector");
        }
        if (SWIG_arg_fail(1)) SWIG_fail;
    }
    result = (LOCA::ParameterVector *)new LOCA::ParameterVector((LOCA::ParameterVector const &)*arg1);

    resultobj = SWIG_NewPointerObj((void*)(result), SWIGTYPE_p_LOCA__ParameterVector, 1);
    return resultobj;
    fail:
    return NULL;
}


static PyObject *_wrap_new_ParameterVector(PyObject *self, PyObject *args) {
    int argc;
    PyObject *argv[2];
    int ii;

    argc = PyObject_Length(args);
    for (ii = 0; (ii < argc) && (ii < 1); ii++) {
        argv[ii] = PyTuple_GetItem(args,ii);
    }
    if (argc == 0) {
        return _wrap_new_ParameterVector__SWIG_0(self,args);
    }
    if (argc == 1) {
        int _v;
        {
            void *ptr = 0;
            if (SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_LOCA__ParameterVector, 0) == -1) {
                _v = 0;
                PyErr_Clear();
            } else {
                _v = (ptr != 0);
            }
        }
        if (_v) {
            return _wrap_new_ParameterVector__SWIG_1(self,args);
        }
    }

    PyErr_SetString(PyExc_NotImplementedError,"No matching function for overloaded 'new_ParameterVector'");
    return NULL;
}


static PyObject *_wrap_ParameterVector_clone(PyObject *, PyObject *args) {
    PyObject *resultobj;
    LOCA::ParameterVector *arg1 = (LOCA::ParameterVector *) 0 ;
    LOCA::ParameterVector *result;
    PyObject * obj0 = 0 ;

    if(!PyArg_ParseTuple(args,(char *)"O:ParameterVector_clone",&obj0)) goto fail;
    SWIG_Python_ConvertPtr(obj0, (void **)&arg1, SWIGTYPE_p_LOCA__ParameterVector, SWIG_POINTER_EXCEPTION | 0);
    if (SWIG_arg_fail(1)) SWIG_fail;
    result = (LOCA::ParameterVector *)((LOCA::ParameterVector const *)arg1)->clone();

    resultobj = SWIG_NewPointerObj((void*)(result), SWIGTYPE_p_LOCA__ParameterVector, 0);
    return resultobj;
    fail:
    return NULL;
}


static PyObject *_wrap_delete_ParameterVector(PyObject *, PyObject *args) {
    PyObject *resultobj;
    LOCA::ParameterVector *arg1 = (LOCA::ParameterVector *) 0 ;
    PyObject * obj0 = 0 ;

    if(!PyArg_ParseTuple(args,(char *)"O:delete_ParameterVector",&obj0)) goto fail;
    SWIG_Python_ConvertPtr(obj0, (void **)&arg1, SWIGTYPE_p_LOCA__ParameterVector, SWIG_POINTER_EXCEPTION | 0);
    if (SWIG_arg_fail(1)) SWIG_fail;
    delete arg1;

    Py_INCREF(Py_None); resultobj = Py_None;
    return resultobj;
    fail:
    return NULL;
}


static PyObject *_wrap_ParameterVector_addParameter__SWIG_0(PyObject *, PyObject *args) {
    PyObject *resultobj;
    LOCA::ParameterVector *arg1 = (LOCA::ParameterVector *) 0 ;
    std::string arg2 ;
    double arg3 ;
    int result;
    PyObject * obj0 = 0 ;
    PyObject * obj1 = 0 ;
    PyObject * obj2 = 0 ;

    if(!PyArg_ParseTuple(args,(char *)"OOO:ParameterVector_addParameter",&obj0,&obj1,&obj2)) goto fail;
    SWIG_Python_ConvertPtr(obj0, (void **)&arg1, SWIGTYPE_p_LOCA__ParameterVector, SWIG_POINTER_EXCEPTION | 0);
    if (SWIG_arg_fail(1)) SWIG_fail;
    {
        std::string *ptr = (std::string *)0;
        int res = SWIG_AsPtr_std_string(obj1, &ptr);
        if (!res) {
            if (!PyErr_Occurred())
            SWIG_type_error("std::string", obj1);
        } else if (!ptr) {
            SWIG_null_ref("std::string");
        }
        if (SWIG_arg_fail(2)) SWIG_fail;
        arg2 = *ptr;
        if (res == SWIG_NEWOBJ) delete ptr;
    }
    {
        arg3 = (double)(SWIG_As_double(obj2));
        if (SWIG_arg_fail(3)) SWIG_fail;
    }
    result = (int)(arg1)->addParameter(arg2,arg3);

    {
        resultobj = SWIG_From_int((int)(result));
    }
    return resultobj;
    fail:
    return NULL;
}


static PyObject *_wrap_ParameterVector_addParameter__SWIG_1(PyObject *, PyObject *args) {
    PyObject *resultobj;
    LOCA::ParameterVector *arg1 = (LOCA::ParameterVector *) 0 ;
    std::string arg2 ;
    int result;
    PyObject * obj0 = 0 ;
    PyObject * obj1 = 0 ;

    if(!PyArg_ParseTuple(args,(char *)"OO:ParameterVector_addParameter",&obj0,&obj1)) goto fail;
    SWIG_Python_ConvertPtr(obj0, (void **)&arg1, SWIGTYPE_p_LOCA__ParameterVector, SWIG_POINTER_EXCEPTION | 0);
    if (SWIG_arg_fail(1)) SWIG_fail;
    {
        std::string *ptr = (std::string *)0;
        int res = SWIG_AsPtr_std_string(obj1, &ptr);
        if (!res) {
            if (!PyErr_Occurred())
            SWIG_type_error("std::string", obj1);
        } else if (!ptr) {
            SWIG_null_ref("std::string");
        }
        if (SWIG_arg_fail(2)) SWIG_fail;
        arg2 = *ptr;
        if (res == SWIG_NEWOBJ) delete ptr;
    }
    result = (int)(arg1)->addParameter(arg2);

    {
        resultobj = SWIG_From_int((int)(result));
    }
    return resultobj;
    fail:
    return NULL;
}


static PyObject *_wrap_ParameterVector_addParameter(PyObject *self, PyObject *args) {
    int argc;
    PyObject *argv[4];
    int ii;

    argc = PyObject_Length(args);
    for (ii = 0; (ii < argc) && (ii < 3); ii++) {
        argv[ii] = PyTuple_GetItem(args,ii);
    }
    if (argc == 2) {
        int _v;
        {
            void *ptr;
            if (SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_LOCA__ParameterVector, 0) == -1) {
                _v = 0;
                PyErr_Clear();
            } else {
                _v = 1;
            }
        }
        if (_v) {
            _v = SWIG_AsPtr_std_string(argv[1], (std::string**)(0));
            if (_v) {
                return _wrap_ParameterVector_addParameter__SWIG_1(self,args);
            }
        }
    }
    if (argc == 3) {
        int _v;
        {
            void *ptr;
            if (SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_LOCA__ParameterVector, 0) == -1) {
                _v = 0;
                PyErr_Clear();
            } else {
                _v = 1;
            }
        }
        if (_v) {
            _v = SWIG_AsPtr_std_string(argv[1], (std::string**)(0));
            if (_v) {
                _v = SWIG_Check_double(argv[2]);
                if (_v) {
                    return _wrap_ParameterVector_addParameter__SWIG_0(self,args);
                }
            }
        }
    }

    PyErr_SetString(PyExc_NotImplementedError,"No matching function for overloaded 'ParameterVector_addParameter'");
    return NULL;
}


static PyObject *_wrap_ParameterVector_init(PyObject *, PyObject *args) {
    PyObject *resultobj;
    LOCA::ParameterVector *arg1 = (LOCA::ParameterVector *) 0 ;
    double arg2 ;
    bool result;
    PyObject * obj0 = 0 ;
    PyObject * obj1 = 0 ;

    if(!PyArg_ParseTuple(args,(char *)"OO:ParameterVector_init",&obj0,&obj1)) goto fail;
    SWIG_Python_ConvertPtr(obj0, (void **)&arg1, SWIGTYPE_p_LOCA__ParameterVector, SWIG_POINTER_EXCEPTION | 0);
    if (SWIG_arg_fail(1)) SWIG_fail;
    {
        arg2 = (double)(SWIG_As_double(obj1));
        if (SWIG_arg_fail(2)) SWIG_fail;
    }
    result = (bool)(arg1)->init(arg2);

    {
        resultobj = SWIG_From_bool((bool)(result));
    }
    return resultobj;
    fail:
    return NULL;
}


static PyObject *_wrap_ParameterVector_scale__SWIG_0(PyObject *, PyObject *args) {
    PyObject *resultobj;
    LOCA::ParameterVector *arg1 = (LOCA::ParameterVector *) 0 ;
    double arg2 ;
    bool result;
    PyObject * obj0 = 0 ;
    PyObject * obj1 = 0 ;

    if(!PyArg_ParseTuple(args,(char *)"OO:ParameterVector_scale",&obj0,&obj1)) goto fail;
    SWIG_Python_ConvertPtr(obj0, (void **)&arg1, SWIGTYPE_p_LOCA__ParameterVector, SWIG_POINTER_EXCEPTION | 0);
    if (SWIG_arg_fail(1)) SWIG_fail;
    {
        arg2 = (double)(SWIG_As_double(obj1));
        if (SWIG_arg_fail(2)) SWIG_fail;
    }
    result = (bool)(arg1)->scale(arg2);

    {
        resultobj = SWIG_From_bool((bool)(result));
    }
    return resultobj;
    fail:
    return NULL;
}


static PyObject *_wrap_ParameterVector_scale__SWIG_1(PyObject *, PyObject *args) {
    PyObject *resultobj;
    LOCA::ParameterVector *arg1 = (LOCA::ParameterVector *) 0 ;
    LOCA::ParameterVector *arg2 = 0 ;
    bool result;
    PyObject * obj0 = 0 ;
    PyObject * obj1 = 0 ;

    if(!PyArg_ParseTuple(args,(char *)"OO:ParameterVector_scale",&obj0,&obj1)) goto fail;
    SWIG_Python_ConvertPtr(obj0, (void **)&arg1, SWIGTYPE_p_LOCA__ParameterVector, SWIG_POINTER_EXCEPTION | 0);
    if (SWIG_arg_fail(1)) SWIG_fail;
    {
        SWIG_Python_ConvertPtr(obj1, (void **)&arg2, SWIGTYPE_p_LOCA__ParameterVector, SWIG_POINTER_EXCEPTION | 0);
        if (SWIG_arg_fail(2)) SWIG_fail;
        if (arg2 == NULL) {
            SWIG_null_ref("LOCA::ParameterVector");
        }
        if (SWIG_arg_fail(2)) SWIG_fail;
    }
    result = (bool)(arg1)->scale((LOCA::ParameterVector const &)*arg2);

    {
        resultobj = SWIG_From_bool((bool)(result));
    }
    return resultobj;
    fail:
    return NULL;
}


static PyObject *_wrap_ParameterVector_scale(PyObject *self, PyObject *args) {
    int argc;
    PyObject *argv[3];
    int ii;

    argc = PyObject_Length(args);
    for (ii = 0; (ii < argc) && (ii < 2); ii++) {
        argv[ii] = PyTuple_GetItem(args,ii);
    }
    if (argc == 2) {
        int _v;
        {
            void *ptr;
            if (SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_LOCA__ParameterVector, 0) == -1) {
                _v = 0;
                PyErr_Clear();
            } else {
                _v = 1;
            }
        }
        if (_v) {
            {
                void *ptr = 0;
                if (SWIG_ConvertPtr(argv[1], &ptr, SWIGTYPE_p_LOCA__ParameterVector, 0) == -1) {
                    _v = 0;
                    PyErr_Clear();
                } else {
                    _v = (ptr != 0);
                }
            }
            if (_v) {
                return _wrap_ParameterVector_scale__SWIG_1(self,args);
            }
        }
    }
    if (argc == 2) {
        int _v;
        {
            void *ptr;
            if (SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_LOCA__ParameterVector, 0) == -1) {
                _v = 0;
                PyErr_Clear();
            } else {
                _v = 1;
            }
        }
        if (_v) {
            _v = SWIG_Check_double(argv[1]);
            if (_v) {
                return _wrap_ParameterVector_scale__SWIG_0(self,args);
            }
        }
    }

    PyErr_SetString(PyExc_NotImplementedError,"No matching function for overloaded 'ParameterVector_scale'");
    return NULL;
}


static PyObject *_wrap_ParameterVector_update(PyObject *, PyObject *args) {
    PyObject *resultobj;
    LOCA::ParameterVector *arg1 = (LOCA::ParameterVector *) 0 ;
    double arg2 ;
    LOCA::ParameterVector *arg3 = 0 ;
    double arg4 ;
    bool result;
    PyObject * obj0 = 0 ;
    PyObject * obj1 = 0 ;
    PyObject * obj2 = 0 ;
    PyObject * obj3 = 0 ;

    if(!PyArg_ParseTuple(args,(char *)"OOOO:ParameterVector_update",&obj0,&obj1,&obj2,&obj3)) goto fail;
    SWIG_Python_ConvertPtr(obj0, (void **)&arg1, SWIGTYPE_p_LOCA__ParameterVector, SWIG_POINTER_EXCEPTION | 0);
    if (SWIG_arg_fail(1)) SWIG_fail;
    {
        arg2 = (double)(SWIG_As_double(obj1));
        if (SWIG_arg_fail(2)) SWIG_fail;
    }
    {
        SWIG_Python_ConvertPtr(obj2, (void **)&arg3, SWIGTYPE_p_LOCA__ParameterVector, SWIG_POINTER_EXCEPTION | 0);
        if (SWIG_arg_fail(3)) SWIG_fail;
        if (arg3 == NULL) {
            SWIG_null_ref("LOCA::ParameterVector");
        }
        if (SWIG_arg_fail(3)) SWIG_fail;
    }
    {
        arg4 = (double)(SWIG_As_double(obj3));
        if (SWIG_arg_fail(4)) SWIG_fail;
    }
    result = (bool)(arg1)->update(arg2,(LOCA::ParameterVector const &)*arg3,arg4);

    {
        resultobj = SWIG_From_bool((bool)(result));
    }
    return resultobj;
    fail:
    return NULL;
}


static PyObject *_wrap_ParameterVector_setValue__SWIG_0(PyObject *, PyObject *args) {
    PyObject *resultobj;
    LOCA::ParameterVector *arg1 = (LOCA::ParameterVector *) 0 ;
    unsigned int arg2 ;
    double arg3 ;
    PyObject * obj0 = 0 ;
    PyObject * obj1 = 0 ;
    PyObject * obj2 = 0 ;

    if(!PyArg_ParseTuple(args,(char *)"OOO:ParameterVector_setValue",&obj0,&obj1,&obj2)) goto fail;
    SWIG_Python_ConvertPtr(obj0, (void **)&arg1, SWIGTYPE_p_LOCA__ParameterVector, SWIG_POINTER_EXCEPTION | 0);
    if (SWIG_arg_fail(1)) SWIG_fail;
    {
        arg2 = (unsigned int)(SWIG_As_unsigned_SS_int(obj1));
        if (SWIG_arg_fail(2)) SWIG_fail;
    }
    {
        arg3 = (double)(SWIG_As_double(obj2));
        if (SWIG_arg_fail(3)) SWIG_fail;
    }
    (arg1)->setValue(arg2,arg3);

    Py_INCREF(Py_None); resultobj = Py_None;
    return resultobj;
    fail:
    return NULL;
}


static PyObject *_wrap_ParameterVector_setValue__SWIG_1(PyObject *, PyObject *args) {
    PyObject *resultobj;
    LOCA::ParameterVector *arg1 = (LOCA::ParameterVector *) 0 ;
    std::string arg2 ;
    double arg3 ;
    PyObject * obj0 = 0 ;
    PyObject * obj1 = 0 ;
    PyObject * obj2 = 0 ;

    if(!PyArg_ParseTuple(args,(char *)"OOO:ParameterVector_setValue",&obj0,&obj1,&obj2)) goto fail;
    SWIG_Python_ConvertPtr(obj0, (void **)&arg1, SWIGTYPE_p_LOCA__ParameterVector, SWIG_POINTER_EXCEPTION | 0);
    if (SWIG_arg_fail(1)) SWIG_fail;
    {
        std::string *ptr = (std::string *)0;
        int res = SWIG_AsPtr_std_string(obj1, &ptr);
        if (!res) {
            if (!PyErr_Occurred())
            SWIG_type_error("std::string", obj1);
        } else if (!ptr) {
            SWIG_null_ref("std::string");
        }
        if (SWIG_arg_fail(2)) SWIG_fail;
        arg2 = *ptr;
        if (res == SWIG_NEWOBJ) delete ptr;
    }
    {
        arg3 = (double)(SWIG_As_double(obj2));
        if (SWIG_arg_fail(3)) SWIG_fail;
    }
    (arg1)->setValue(arg2,arg3);

    Py_INCREF(Py_None); resultobj = Py_None;
    return resultobj;
    fail:
    return NULL;
}


static PyObject *_wrap_ParameterVector_setValue(PyObject *self, PyObject *args) {
    int argc;
    PyObject *argv[4];
    int ii;

    argc = PyObject_Length(args);
    for (ii = 0; (ii < argc) && (ii < 3); ii++) {
        argv[ii] = PyTuple_GetItem(args,ii);
    }
    if (argc == 3) {
        int _v;
        {
            void *ptr;
            if (SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_LOCA__ParameterVector, 0) == -1) {
                _v = 0;
                PyErr_Clear();
            } else {
                _v = 1;
            }
        }
        if (_v) {
            _v = SWIG_Check_unsigned_SS_int(argv[1]);
            if (_v) {
                _v = SWIG_Check_double(argv[2]);
                if (_v) {
                    return _wrap_ParameterVector_setValue__SWIG_0(self,args);
                }
            }
        }
    }
    if (argc == 3) {
        int _v;
        {
            void *ptr;
            if (SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_LOCA__ParameterVector, 0) == -1) {
                _v = 0;
                PyErr_Clear();
            } else {
                _v = 1;
            }
        }
        if (_v) {
            _v = SWIG_AsPtr_std_string(argv[1], (std::string**)(0));
            if (_v) {
                _v = SWIG_Check_double(argv[2]);
                if (_v) {
                    return _wrap_ParameterVector_setValue__SWIG_1(self,args);
                }
            }
        }
    }

    PyErr_SetString(PyExc_NotImplementedError,"No matching function for overloaded 'ParameterVector_setValue'");
    return NULL;
}


static PyObject *_wrap_ParameterVector_getValue__SWIG_0(PyObject *, PyObject *args) {
    PyObject *resultobj;
    LOCA::ParameterVector *arg1 = (LOCA::ParameterVector *) 0 ;
    unsigned int arg2 ;
    double result;
    PyObject * obj0 = 0 ;
    PyObject * obj1 = 0 ;

    if(!PyArg_ParseTuple(args,(char *)"OO:ParameterVector_getValue",&obj0,&obj1)) goto fail;
    SWIG_Python_ConvertPtr(obj0, (void **)&arg1, SWIGTYPE_p_LOCA__ParameterVector, SWIG_POINTER_EXCEPTION | 0);
    if (SWIG_arg_fail(1)) SWIG_fail;
    {
        arg2 = (unsigned int)(SWIG_As_unsigned_SS_int(obj1));
        if (SWIG_arg_fail(2)) SWIG_fail;
    }
    result = (double)((LOCA::ParameterVector const *)arg1)->getValue(arg2);

    {
        resultobj = SWIG_From_double((double)(result));
    }
    return resultobj;
    fail:
    return NULL;
}


static PyObject *_wrap_ParameterVector_getValue__SWIG_1(PyObject *, PyObject *args) {
    PyObject *resultobj;
    LOCA::ParameterVector *arg1 = (LOCA::ParameterVector *) 0 ;
    std::string arg2 ;
    double result;
    PyObject * obj0 = 0 ;
    PyObject * obj1 = 0 ;

    if(!PyArg_ParseTuple(args,(char *)"OO:ParameterVector_getValue",&obj0,&obj1)) goto fail;
    SWIG_Python_ConvertPtr(obj0, (void **)&arg1, SWIGTYPE_p_LOCA__ParameterVector, SWIG_POINTER_EXCEPTION | 0);
    if (SWIG_arg_fail(1)) SWIG_fail;
    {
        std::string *ptr = (std::string *)0;
        int res = SWIG_AsPtr_std_string(obj1, &ptr);
        if (!res) {
            if (!PyErr_Occurred())
            SWIG_type_error("std::string", obj1);
        } else if (!ptr) {
            SWIG_null_ref("std::string");
        }
        if (SWIG_arg_fail(2)) SWIG_fail;
        arg2 = *ptr;
        if (res == SWIG_NEWOBJ) delete ptr;
    }
    result = (double)((LOCA::ParameterVector const *)arg1)->getValue(arg2);

    {
        resultobj = SWIG_From_double((double)(result));
    }
    return resultobj;
    fail:
    return NULL;
}


static PyObject *_wrap_ParameterVector_getValue(PyObject *self, PyObject *args) {
    int argc;
    PyObject *argv[3];
    int ii;

    argc = PyObject_Length(args);
    for (ii = 0; (ii < argc) && (ii < 2); ii++) {
        argv[ii] = PyTuple_GetItem(args,ii);
    }
    if (argc == 2) {
        int _v;
        {
            void *ptr;
            if (SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_LOCA__ParameterVector, 0) == -1) {
                _v = 0;
                PyErr_Clear();
            } else {
                _v = 1;
            }
        }
        if (_v) {
            _v = SWIG_Check_unsigned_SS_int(argv[1]);
            if (_v) {
                return _wrap_ParameterVector_getValue__SWIG_0(self,args);
            }
        }
    }
    if (argc == 2) {
        int _v;
        {
            void *ptr;
            if (SWIG_ConvertPtr(argv[0], &ptr, SWIGTYPE_p_LOCA__ParameterVector, 0) == -1) {
                _v = 0;
                PyErr_Clear();
            } else {
                _v = 1;
            }
        }
        if (_v) {
            _v = SWIG_AsPtr_std_string(argv[1], (std::string**)(0));
            if (_v) {
                return _wrap_ParameterVector_getValue__SWIG_1(self,args);
            }
        }
    }

    PyErr_SetString(PyExc_NotImplementedError,"No matching function for overloaded 'ParameterVector_getValue'");
    return NULL;
}


static PyObject *_wrap_ParameterVector_getIndex(PyObject *, PyObject *args) {
    PyObject *resultobj;
    LOCA::ParameterVector *arg1 = (LOCA::ParameterVector *) 0 ;
    std::string arg2 ;
    int result;
    PyObject * obj0 = 0 ;
    PyObject * obj1 = 0 ;

    if(!PyArg_ParseTuple(args,(char *)"OO:ParameterVector_getIndex",&obj0,&obj1)) goto fail;
    SWIG_Python_ConvertPtr(obj0, (void **)&arg1, SWIGTYPE_p_LOCA__ParameterVector, SWIG_POINTER_EXCEPTION | 0);
    if (SWIG_arg_fail(1)) SWIG_fail;
    {
        std::string *ptr = (std::string *)0;
        int res = SWIG_AsPtr_std_string(obj1, &ptr);
        if (!res) {
            if (!PyErr_Occurred())
            SWIG_type_error("std::string", obj1);
        } else if (!ptr) {
            SWIG_null_ref("std::string");
        }
        if (SWIG_arg_fail(2)) SWIG_fail;
        arg2 = *ptr;
        if (res == SWIG_NEWOBJ) delete ptr;
    }
    result = (int)((LOCA::ParameterVector const *)arg1)->getIndex(arg2);

    {
        resultobj = SWIG_From_int((int)(result));
    }
    return resultobj;
    fail:
    return NULL;
}


static PyObject *_wrap_ParameterVector_getDoubleArrayPointer(PyObject *, PyObject *args) {
    PyObject *resultobj;
    LOCA::ParameterVector *arg1 = (LOCA::ParameterVector *) 0 ;
    double *result;
    PyObject * obj0 = 0 ;

    if(!PyArg_ParseTuple(args,(char *)"O:ParameterVector_getDoubleArrayPointer",&obj0)) goto fail;
    SWIG_Python_ConvertPtr(obj0, (void **)&arg1, SWIGTYPE_p_LOCA__ParameterVector, SWIG_POINTER_EXCEPTION | 0);
    if (SWIG_arg_fail(1)) SWIG_fail;
    result = (double *)(arg1)->getDoubleArrayPointer();

    resultobj = SWIG_NewPointerObj((void*)(result), SWIGTYPE_p_double, 0);
    return resultobj;
    fail:
    return NULL;
}


static PyObject *_wrap_ParameterVector_isParameter(PyObject *, PyObject *args) {
    PyObject *resultobj;
    LOCA::ParameterVector *arg1 = (LOCA::ParameterVector *) 0 ;
    std::string arg2 ;
    bool result;
    PyObject * obj0 = 0 ;
    PyObject * obj1 = 0 ;

    if(!PyArg_ParseTuple(args,(char *)"OO:ParameterVector_isParameter",&obj0,&obj1)) goto fail;
    SWIG_Python_ConvertPtr(obj0, (void **)&arg1, SWIGTYPE_p_LOCA__ParameterVector, SWIG_POINTER_EXCEPTION | 0);
    if (SWIG_arg_fail(1)) SWIG_fail;
    {
        std::string *ptr = (std::string *)0;
        int res = SWIG_AsPtr_std_string(obj1, &ptr);
        if (!res) {
            if (!PyErr_Occurred())
            SWIG_type_error("std::string", obj1);
        } else if (!ptr) {
            SWIG_null_ref("std::string");
        }
        if (SWIG_arg_fail(2)) SWIG_fail;
        arg2 = *ptr;
        if (res == SWIG_NEWOBJ) delete ptr;
    }
    result = (bool)((LOCA::ParameterVector const *)arg1)->isParameter(arg2);

    {
        resultobj = SWIG_From_bool((bool)(result));
    }
    return resultobj;
    fail:
    return NULL;
}


static PyObject *_wrap_ParameterVector_getLabel(PyObject *, PyObject *args) {
    PyObject *resultobj;
    LOCA::ParameterVector *arg1 = (LOCA::ParameterVector *) 0 ;
    unsigned int arg2 ;
    std::string result;
    PyObject * obj0 = 0 ;
    PyObject * obj1 = 0 ;

    if(!PyArg_ParseTuple(args,(char *)"OO:ParameterVector_getLabel",&obj0,&obj1)) goto fail;
    SWIG_Python_ConvertPtr(obj0, (void **)&arg1, SWIGTYPE_p_LOCA__ParameterVector, SWIG_POINTER_EXCEPTION | 0);
    if (SWIG_arg_fail(1)) SWIG_fail;
    {
        arg2 = (unsigned int)(SWIG_As_unsigned_SS_int(obj1));
        if (SWIG_arg_fail(2)) SWIG_fail;
    }
    result = ((LOCA::ParameterVector const *)arg1)->getLabel(arg2);

    {
        resultobj = SWIG_From_std_string((std::string)(result));
    }
    return resultobj;
    fail:
    return NULL;
}


static PyObject *_wrap_ParameterVector_length(PyObject *, PyObject *args) {
    PyObject *resultobj;
    LOCA::ParameterVector *arg1 = (LOCA::ParameterVector *) 0 ;
    int result;
    PyObject * obj0 = 0 ;

    if(!PyArg_ParseTuple(args,(char *)"O:ParameterVector_length",&obj0)) goto fail;
    SWIG_Python_ConvertPtr(obj0, (void **)&arg1, SWIGTYPE_p_LOCA__ParameterVector, SWIG_POINTER_EXCEPTION | 0);
    if (SWIG_arg_fail(1)) SWIG_fail;
    result = (int)((LOCA::ParameterVector const *)arg1)->length();

    {
        resultobj = SWIG_From_int((int)(result));
    }
    return resultobj;
    fail:
    return NULL;
}


static PyObject *_wrap_ParameterVector_Print(PyObject *, PyObject *args) {
    PyObject *resultobj;
    LOCA::ParameterVector *arg1 = (LOCA::ParameterVector *) 0 ;
    std::ostream *arg2 = 0 ;
    PyObject * obj0 = 0 ;
    PyObject * obj1 = 0 ;

    if(!PyArg_ParseTuple(args,(char *)"OO:ParameterVector_Print",&obj0,&obj1)) goto fail;
    SWIG_Python_ConvertPtr(obj0, (void **)&arg1, SWIGTYPE_p_LOCA__ParameterVector, SWIG_POINTER_EXCEPTION | 0);
    if (SWIG_arg_fail(1)) SWIG_fail;
    {
        SWIG_Python_ConvertPtr(obj1, (void **)&arg2, SWIGTYPE_p_ostream, SWIG_POINTER_EXCEPTION | 0);
        if (SWIG_arg_fail(2)) SWIG_fail;
        if (arg2 == NULL) {
            SWIG_null_ref("ostream");
        }
        if (SWIG_arg_fail(2)) SWIG_fail;
    }
    ((LOCA::ParameterVector const *)arg1)->print(*arg2);

    Py_INCREF(Py_None); resultobj = Py_None;
    return resultobj;
    fail:
    return NULL;
}


static PyObject *_wrap_ParameterVector_getValuesVector(PyObject *, PyObject *args) {
    PyObject *resultobj;
    LOCA::ParameterVector *arg1 = (LOCA::ParameterVector *) 0 ;
    std::vector<double > *result;
    PyObject * obj0 = 0 ;

    if(!PyArg_ParseTuple(args,(char *)"O:ParameterVector_getValuesVector",&obj0)) goto fail;
    SWIG_Python_ConvertPtr(obj0, (void **)&arg1, SWIGTYPE_p_LOCA__ParameterVector, SWIG_POINTER_EXCEPTION | 0);
    if (SWIG_arg_fail(1)) SWIG_fail;
    {
        std::vector<double > const &_result_ref = ((LOCA::ParameterVector const *)arg1)->getValuesVector();
        result = (std::vector<double > *) &_result_ref;
    }

    resultobj = SWIG_NewPointerObj((void*)(result), SWIGTYPE_p_vectorTdouble_t, 0);
    return resultobj;
    fail:
    return NULL;
}


static PyObject *_wrap_ParameterVector_getNamesVector(PyObject *, PyObject *args) {
    PyObject *resultobj;
    LOCA::ParameterVector *arg1 = (LOCA::ParameterVector *) 0 ;
    std::vector<std::string > *result;
    PyObject * obj0 = 0 ;

    if(!PyArg_ParseTuple(args,(char *)"O:ParameterVector_getNamesVector",&obj0)) goto fail;
    SWIG_Python_ConvertPtr(obj0, (void **)&arg1, SWIGTYPE_p_LOCA__ParameterVector, SWIG_POINTER_EXCEPTION | 0);
    if (SWIG_arg_fail(1)) SWIG_fail;
    {
        std::vector<std::string > const &_result_ref = ((LOCA::ParameterVector const *)arg1)->getNamesVector();
        result = (std::vector<std::string > *) &_result_ref;
    }

    resultobj = SWIG_NewPointerObj((void*)(result), SWIGTYPE_p_vectorTstd__string_t, 0);
    return resultobj;
    fail:
    return NULL;
}


static PyObject * ParameterVector_swigregister(PyObject *, PyObject *args) {
    PyObject *obj;
    if (!PyArg_ParseTuple(args,(char*)"O", &obj)) return NULL;
    SWIG_TypeClientData(SWIGTYPE_p_LOCA__ParameterVector, obj);
    Py_INCREF(obj);
    return Py_BuildValue((char *)"");
}
static PyObject *_wrap_new_Utils(PyObject *, PyObject *args) {
    PyObject *resultobj;
    Utils *result;

    if(!PyArg_ParseTuple(args,(char *)":new_Utils")) goto fail;
    result = (Utils *)new Utils();

    resultobj = SWIG_NewPointerObj((void*)(result), SWIGTYPE_p_Utils, 1);
    return resultobj;
    fail:
    return NULL;
}


static PyObject *_wrap_delete_Utils(PyObject *, PyObject *args) {
    PyObject *resultobj;
    Utils *arg1 = (Utils *) 0 ;
    PyObject * obj0 = 0 ;

    if(!PyArg_ParseTuple(args,(char *)"O:delete_Utils",&obj0)) goto fail;
    SWIG_Python_ConvertPtr(obj0, (void **)&arg1, SWIGTYPE_p_Utils, SWIG_POINTER_EXCEPTION | 0);
    if (SWIG_arg_fail(1)) SWIG_fail;
    delete arg1;

    Py_INCREF(Py_None); resultobj = Py_None;
    return resultobj;
    fail:
    return NULL;
}


static PyObject * Utils_swigregister(PyObject *, PyObject *args) {
    PyObject *obj;
    if (!PyArg_ParseTuple(args,(char*)"O", &obj)) return NULL;
    SWIG_TypeClientData(SWIGTYPE_p_Utils, obj);
    Py_INCREF(obj);
    return Py_BuildValue((char *)"");
}
static PyMethodDef SwigMethods[] = {
     { (char *)"delete_Iterator", _wrap_delete_Iterator, METH_VARARGS, NULL},
     { (char *)"Iterator_resetIterator", _wrap_Iterator_resetIterator, METH_VARARGS, NULL},
     { (char *)"Iterator_getIteratorStatus", _wrap_Iterator_getIteratorStatus, METH_VARARGS, NULL},
     { (char *)"Iterator_getStepNumber", _wrap_Iterator_getStepNumber, METH_VARARGS, NULL},
     { (char *)"Iterator_getNumFailedSteps", _wrap_Iterator_getNumFailedSteps, METH_VARARGS, NULL},
     { (char *)"Iterator_getNumTotalSteps", _wrap_Iterator_getNumTotalSteps, METH_VARARGS, NULL},
     { (char *)"Iterator_run", _wrap_Iterator_run, METH_VARARGS, NULL},
     { (char *)"Iterator_swigregister", Iterator_swigregister, METH_VARARGS, NULL},
     { (char *)"new_Stepper", _wrap_new_Stepper, METH_VARARGS, NULL},
     { (char *)"delete_Stepper", _wrap_delete_Stepper, METH_VARARGS, NULL},
     { (char *)"Stepper_reset", _wrap_Stepper_reset, METH_VARARGS, NULL},
     { (char *)"Stepper_getSolutionGroup", _wrap_Stepper_getSolutionGroup, METH_VARARGS, NULL},
     { (char *)"Stepper_getBifurcationGroup", _wrap_Stepper_getBifurcationGroup, METH_VARARGS, NULL},
     { (char *)"Stepper_getParameterList", _wrap_Stepper_getParameterList, METH_VARARGS, NULL},
     { (char *)"Stepper_getSolver", _wrap_Stepper_getSolver, METH_VARARGS, NULL},
     { (char *)"Stepper_swigregister", Stepper_swigregister, METH_VARARGS, NULL},
     { (char *)"new_ParameterVector", _wrap_new_ParameterVector, METH_VARARGS, NULL},
     { (char *)"ParameterVector_clone", _wrap_ParameterVector_clone, METH_VARARGS, NULL},
     { (char *)"delete_ParameterVector", _wrap_delete_ParameterVector, METH_VARARGS, NULL},
     { (char *)"ParameterVector_addParameter", _wrap_ParameterVector_addParameter, METH_VARARGS, NULL},
     { (char *)"ParameterVector_init", _wrap_ParameterVector_init, METH_VARARGS, NULL},
     { (char *)"ParameterVector_scale", _wrap_ParameterVector_scale, METH_VARARGS, NULL},
     { (char *)"ParameterVector_update", _wrap_ParameterVector_update, METH_VARARGS, NULL},
     { (char *)"ParameterVector_setValue", _wrap_ParameterVector_setValue, METH_VARARGS, NULL},
     { (char *)"ParameterVector_getValue", _wrap_ParameterVector_getValue, METH_VARARGS, NULL},
     { (char *)"ParameterVector_getIndex", _wrap_ParameterVector_getIndex, METH_VARARGS, NULL},
     { (char *)"ParameterVector_getDoubleArrayPointer", _wrap_ParameterVector_getDoubleArrayPointer, METH_VARARGS, NULL},
     { (char *)"ParameterVector_isParameter", _wrap_ParameterVector_isParameter, METH_VARARGS, NULL},
     { (char *)"ParameterVector_getLabel", _wrap_ParameterVector_getLabel, METH_VARARGS, NULL},
     { (char *)"ParameterVector_length", _wrap_ParameterVector_length, METH_VARARGS, NULL},
     { (char *)"ParameterVector_Print", _wrap_ParameterVector_Print, METH_VARARGS, NULL},
     { (char *)"ParameterVector_getValuesVector", _wrap_ParameterVector_getValuesVector, METH_VARARGS, NULL},
     { (char *)"ParameterVector_getNamesVector", _wrap_ParameterVector_getNamesVector, METH_VARARGS, NULL},
     { (char *)"ParameterVector_swigregister", ParameterVector_swigregister, METH_VARARGS, NULL},
     { (char *)"new_Utils", _wrap_new_Utils, METH_VARARGS, NULL},
     { (char *)"delete_Utils", _wrap_delete_Utils, METH_VARARGS, NULL},
     { (char *)"Utils_swigregister", Utils_swigregister, METH_VARARGS, NULL},
     { NULL, NULL, 0, NULL }
};


/* -------- TYPE CONVERSION AND EQUIVALENCE RULES (BEGIN) -------- */

static void *_p_LOCA__StepperTo_p_LOCA__Abstract__Iterator(void *x) {
    return (void *)((LOCA::Abstract::Iterator *)  ((LOCA::Stepper *) x));
}
static swig_type_info _swigt__p_LOCA__ParameterVector[] = {{"_p_LOCA__ParameterVector", 0, "LOCA::ParameterVector *", 0, 0, 0, 0},{"_p_LOCA__ParameterVector", 0, 0, 0, 0, 0, 0},{0, 0, 0, 0, 0, 0, 0}};
static swig_type_info _swigt__std__size_t[] = {{"_std__size_t", 0, "std::size_t", 0, 0, 0, 0},{"_std__size_t", 0, 0, 0, 0, 0, 0},{0, 0, 0, 0, 0, 0, 0}};
static swig_type_info _swigt__size_t[] = {{"_size_t", 0, "size_t", 0, 0, 0, 0},{"_size_t", 0, 0, 0, 0, 0, 0},{0, 0, 0, 0, 0, 0, 0}};
static swig_type_info _swigt__p_double[] = {{"_p_double", 0, "double *", 0, 0, 0, 0},{"_p_double", 0, 0, 0, 0, 0, 0},{0, 0, 0, 0, 0, 0, 0}};
static swig_type_info _swigt__p_Teuchos__RefCountPtrTLOCA__Abstract__Factory_t[] = {{"_p_Teuchos__RefCountPtrTLOCA__Abstract__Factory_t", 0, "Teuchos::RCP<LOCA::Abstract::Factory > *", 0, 0, 0, 0},{"_p_Teuchos__RefCountPtrTLOCA__Abstract__Factory_t", 0, 0, 0, 0, 0, 0},{0, 0, 0, 0, 0, 0, 0}};
static swig_type_info _swigt__p_NOX__Parameter__List[] = {{"_p_NOX__Parameter__List", 0, "NOX::Parameter::List *", 0, 0, 0, 0},{"_p_NOX__Parameter__List", 0, 0, 0, 0, 0, 0},{0, 0, 0, 0, 0, 0, 0}};
static swig_type_info _swigt__p_vectorTdouble_t[] = {{"_p_vectorTdouble_t", 0, "vector<double > *", 0, 0, 0, 0},{"_p_vectorTdouble_t", 0, 0, 0, 0, 0, 0},{0, 0, 0, 0, 0, 0, 0}};
static swig_type_info _swigt__p_char[] = {{"_p_char", 0, "char *", 0, 0, 0, 0},{"_p_char", 0, 0, 0, 0, 0, 0},{0, 0, 0, 0, 0, 0, 0}};
static swig_type_info _swigt__p_LOCA__Continuation__AbstractGroup[] = {{"_p_LOCA__Continuation__AbstractGroup", 0, "LOCA::Continuation::AbstractGroup *", 0, 0, 0, 0},{"_p_LOCA__Continuation__AbstractGroup", 0, 0, 0, 0, 0, 0},{0, 0, 0, 0, 0, 0, 0}};
static swig_type_info _swigt__p_ostream[] = {{"_p_ostream", 0, "ostream *", 0, 0, 0, 0},{"_p_ostream", 0, 0, 0, 0, 0, 0},{0, 0, 0, 0, 0, 0, 0}};
static swig_type_info _swigt__std__ptrdiff_t[] = {{"_std__ptrdiff_t", 0, "std::ptrdiff_t", 0, 0, 0, 0},{"_std__ptrdiff_t", 0, 0, 0, 0, 0, 0},{0, 0, 0, 0, 0, 0, 0}};
static swig_type_info _swigt__ptrdiff_t[] = {{"_ptrdiff_t", 0, "ptrdiff_t", 0, 0, 0, 0},{"_ptrdiff_t", 0, 0, 0, 0, 0, 0},{0, 0, 0, 0, 0, 0, 0}};
static swig_type_info _swigt__p_vectorTstd__string_t[] = {{"_p_vectorTstd__string_t", 0, "vector<std::string > *", 0, 0, 0, 0},{"_p_vectorTstd__string_t", 0, 0, 0, 0, 0, 0},{0, 0, 0, 0, 0, 0, 0}};
static swig_type_info _swigt__p_Utils[] = {{"_p_Utils", 0, "Utils *", 0, 0, 0, 0},{"_p_Utils", 0, 0, 0, 0, 0, 0},{0, 0, 0, 0, 0, 0, 0}};
static swig_type_info _swigt__p_NOX__Solver__Generic[] = {{"_p_NOX__Solver__Generic", 0, "NOX::Solver::Generic *", 0, 0, 0, 0},{"_p_NOX__Solver__Generic", 0, 0, 0, 0, 0, 0},{0, 0, 0, 0, 0, 0, 0}};
static swig_type_info _swigt__p_LOCA__Stepper[] = {{"_p_LOCA__Stepper", 0, "LOCA::Stepper *", 0, 0, 0, 0},{"_p_LOCA__Stepper", 0, 0, 0, 0, 0, 0},{0, 0, 0, 0, 0, 0, 0}};
static swig_type_info _swigt__p_NOX__StatusTest__Generic[] = {{"_p_NOX__StatusTest__Generic", 0, "NOX::StatusTest::Generic *", 0, 0, 0, 0},{"_p_NOX__StatusTest__Generic", 0, 0, 0, 0, 0, 0},{0, 0, 0, 0, 0, 0, 0}};
static swig_type_info _swigt__p_LOCA__Abstract__Iterator[] = {{"_p_LOCA__Abstract__Iterator", 0, "LOCA::Abstract::Iterator *", 0, 0, 0, 0},{"_p_LOCA__Abstract__Iterator", 0, 0, 0, 0, 0, 0},{"_p_LOCA__Stepper", _p_LOCA__StepperTo_p_LOCA__Abstract__Iterator, 0, 0, 0, 0, 0},{0, 0, 0, 0, 0, 0, 0}};

static swig_type_info *swig_types_initial[] = {
_swigt__p_LOCA__ParameterVector,
_swigt__std__size_t,
_swigt__size_t,
_swigt__p_double,
_swigt__p_Teuchos__RefCountPtrTLOCA__Abstract__Factory_t,
_swigt__p_NOX__Parameter__List,
_swigt__p_vectorTdouble_t,
_swigt__p_char,
_swigt__p_LOCA__Continuation__AbstractGroup,
_swigt__p_ostream,
_swigt__std__ptrdiff_t,
_swigt__ptrdiff_t,
_swigt__p_vectorTstd__string_t,
_swigt__p_Utils,
_swigt__p_NOX__Solver__Generic,
_swigt__p_LOCA__Stepper,
_swigt__p_NOX__StatusTest__Generic,
_swigt__p_LOCA__Abstract__Iterator,
0
};


/* -------- TYPE CONVERSION AND EQUIVALENCE RULES (END) -------- */

static swig_const_info swig_const_table[] = {
{0, 0, 0, 0.0, 0, 0}};

#ifdef __cplusplus
}
#endif


#ifdef SWIG_LINK_RUNTIME
#if defined(_WIN32) || defined(__WIN32__) || defined(__CYGWIN__)
#  if defined(_MSC_VER) || defined(__GNUC__)
#    define SWIGIMPORT(a) extern a
#  else
#    if defined(__BORLANDC__)
#      define SWIGIMPORT(a) a _export
#    else
#      define SWIGIMPORT(a) a
#    endif
#  endif
#else
#  define SWIGIMPORT(a) a
#endif
#ifdef __cplusplus
extern "C"
#endif
SWIGEXPORT(void *) SWIG_ReturnGlobalTypeList(void *);
#endif

#ifdef __cplusplus
extern "C"
#endif
SWIGEXPORT(void) SWIG_init(void) {
    static PyObject *SWIG_globals = 0;
    static int       typeinit = 0;
    PyObject *m, *d;
    int       i;
    if (!SWIG_globals) SWIG_globals = SWIG_newvarlink();

    /* Fix SwigMethods to carry the callback ptrs when needed */
    SWIG_Python_FixMethods(SwigMethods, swig_const_table, swig_types, swig_types_initial);

    m = Py_InitModule((char *) SWIG_name, SwigMethods);
    d = PyModule_GetDict(m);

    if (!typeinit) {
#ifdef SWIG_LINK_RUNTIME
        swig_type_list_handle = (swig_type_info **) SWIG_ReturnGlobalTypeList(swig_type_list_handle);
#else
#  ifndef SWIG_STATIC_RUNTIME
        SWIG_Python_LookupTypePointer(&swig_type_list_handle);
#  endif
#endif
        for (i = 0; swig_types_initial[i]; i++) {
            swig_types[i] = SWIG_TypeRegister(swig_types_initial[i]);
        }
        typeinit = 1;
    }
    SWIG_InstallConstants(d,swig_const_table);

    {
        PyDict_SetItemString(d,"Iterator_LastIteration", SWIG_From_int((int)(LOCA::Abstract::Iterator::LastIteration)));
    }
    {
        PyDict_SetItemString(d,"Iterator_Finished", SWIG_From_int((int)(LOCA::Abstract::Iterator::Finished)));
    }
    {
        PyDict_SetItemString(d,"Iterator_Failed", SWIG_From_int((int)(LOCA::Abstract::Iterator::Failed)));
    }
    {
        PyDict_SetItemString(d,"Iterator_NotFinished", SWIG_From_int((int)(LOCA::Abstract::Iterator::NotFinished)));
    }
    {
        PyDict_SetItemString(d,"Iterator_Successful", SWIG_From_int((int)(LOCA::Abstract::Iterator::Successful)));
    }
    {
        PyDict_SetItemString(d,"Iterator_Unsuccessful", SWIG_From_int((int)(LOCA::Abstract::Iterator::Unsuccessful)));
    }
    {
        PyDict_SetItemString(d,"Iterator_Provisional", SWIG_From_int((int)(LOCA::Abstract::Iterator::Provisional)));
    }
    {
        PyDict_SetItemString(d,"Utils_Error", SWIG_From_int((int)(Utils::Error)));
    }
    {
        PyDict_SetItemString(d,"Utils_Warning", SWIG_From_int((int)(Utils::Warning)));
    }
    {
        PyDict_SetItemString(d,"Utils_StepperIteration", SWIG_From_int((int)(Utils::StepperIteration)));
    }
    {
        PyDict_SetItemString(d,"Utils_StepperDetails", SWIG_From_int((int)(Utils::StepperDetails)));
    }
    {
        PyDict_SetItemString(d,"Utils_Solver", SWIG_From_int((int)(Utils::Solver)));
    }
    {
        PyDict_SetItemString(d,"Utils_SolverDetails", SWIG_From_int((int)(Utils::SolverDetails)));
    }
    {
        PyDict_SetItemString(d,"Utils_Direction", SWIG_From_int((int)(Utils::Direction)));
    }
    {
        PyDict_SetItemString(d,"Utils_Parameters", SWIG_From_int((int)(Utils::Parameters)));
    }
}

